#include "main.h"
#include "1942vid.h"
#include "invvid.h"
#include "globals.h"
#include "twk.h"

int *p1942BackDirt;
pBYTE p1942Background;
int *p1942tlkup;

pBYTE p1942BankMem;
static int ingame=0;

static int rst[]={0x08,0x10};
static int rstflip=0;
pBYTE p1942BackOut2;
pBYTE p1942BackIn2;
extern int upd;


void _1942bank(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   p1942BankMem=pCode+0x9000+((value&3)*0x4000);
}

UINT8 _1942bankread(UINT32 offset, struct MemoryReadByte *mrb)
{
   return p1942BankMem[offset];;
}

void _1942flip(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   flipscreenw(0,value>>7,0);
}

void init1942(void)
{
   p1942Background=myalloc(256*512);
   p1942BackDirt=myalloc(32*16*sizeof(int));
   p1942tlkup=myalloc(1024*sizeof(int));

   p1942BankMem=pCode;

   transcol=0;

   memset(p1942Background,0,256*512);
   memset(p1942BackDirt,0x0f,32*16*sizeof(int));
}

void clear1942(void)
{
   myfree(p1942BackDirt);
   myfree(p1942Background);
   myfree(p1942tlkup);
}

void _1942int(void)
{
   int upf;
   z80intAddr=rst[rstflip];
   mz80int(0xff);
   upf=0;
   if(!pCode[0xc802]&&!pCode[0xc803]&&pCode[0xd895]==142)
      upf=1;

   if(rstflip==upf&&upd)
      update1942scr();

   rstflip=!rstflip;
}


void update1942scr(void)
{
   pBYTE pWork;
   pBYTE pWork2;

   static BYTE oldback=0xff;
   int temp;
   int dummy1,dummy2,dummy3,dummy4,dummy5;
   int x,y,idx,col,x2,y2,idxx,idxy,prey;
   int x1,y1,spr,nspr,si,cpy1,cpy2,xpos;
   int nsa[]={0,1,3};
   int flpx,flpy;

   pBYTE pCol;
   int scrl;
   BYTE out;
   BYTE bb;


   if(realorient)
   {
      if(FlipScreen)
      {
//background
         if(background)
         {
            idxx=0;
            bb=(pCode[0xc805]&0x03)<<5;
            for(idx=1023;idx>=0;idx--)
            {
               if(!(idx&0x10))
               {
                  spr=pCode[0xd800+idx]+((pCode[0xd800+idx+16]&0x80)<<1);
                  col=(pCode[0xd800+idx+16]&0x1f)|bb;
                  if(oldback!=bb||p1942BackDirt[idxx]!=(spr|(col<<9)))
                  {
                     x=(idx>>5);
                     {
                        y=15-(idx&0x1f);
                        flpx=!(pCode[0xd800+16+idx]&0x20);
                        flpy=(pCode[0xd800+16+idx]&0x40);
                        disptile(x,y,spr,flpx,flpy,col);
                        p1942BackDirt[idxx]=spr|(col<<9);
                     }
                  }
                  idxx++;
               }
            }
            oldback=bb;
            xpos=(pCode[0xc802]+((pCode[0xc803]&0x01)<<8));
            pWork=pBoard->pScreen;
            pWork2=p1942Background+0x2000+xpos;

            cpy1=xpos;
            cpy2=0;
            if(cpy1<256)
               cpy1=256;
            else
            {
               cpy2=cpy1-256;
               cpy1=512-cpy1;
            }
            if(cpy2)
            {
               for(y=0;y<224;y++)
               {
                  memcpy(pWork,pWork2,cpy1);
                  memcpy(pWork+cpy1,pWork2-xpos,cpy2);
                  pWork+=512;
                  pWork2+=512;
               }
            }
            else
            {
               for(y=0;y<224;y++)
               {
                  memcpy(pWork,pWork2,256);
                  pWork+=512;
                  pWork2+=512;
               }
            }
         }
         else
            fastclear();
//sprites
         transcol=15;
         for(idx=0xcc7c;idx>=0xcc00;idx-=4)
         {
            col=(pCode[idx+1]&0x0f);
            x=(pCode[idx+3]-((pCode[idx+1]&0x10)<<4));
            y=pCode[idx+2];

            if(x&&y)
            {
               nspr=nsa[(pCode[idx+1]&0xc0)>>6];
               y+=nspr<<4;
               spr=(pCode[idx]&0x7f)+((pCode[idx+1]&0x20)<<2)+((pCode[idx]&0x80)<<1)+nspr;
               for(si=0;si<=nspr;si++,spr--,y-=16)
                  sprblit(x,y,spr,col,FlipScreen,FlipScreen);
            }
         }
//chars
         pWork=pScreen;
         pWork2=&pCode[0xd000];
         pCol=&pCode[0xd400];
         transcol=0;
         for(y=0;y<30;y++)
         {
            prey=y<<3;
            for(x=0;x<32;x++,pWork2++,pCol++)
            {
               spr=*pWork2+((*pCol&0x80)<<1);
               if(spr!=48)
                  disptranschar(x<<3,prey,spr,*pCol&0x3f);
            }
         }
      }
      else
      {
//background
         if(background)
         {
            idxx=0;
            bb=(pCode[0xc805]&0x03)<<5;
            for(idx=1023;idx>=0;idx--)
            {
               if(!(idx&0x10))
               {
                  spr=pCode[0xd800+idx]+((pCode[0xd800+idx+16]&0x80)<<1);
                  col=(pCode[0xd800+idx+16]&0x1f)|bb;
                  if(oldback!=bb||p1942BackDirt[idxx]!=(spr|(col<<9)))
                  {
                     x=31-(idx>>5);
                     {
                        y=15-(idx&0x1f);
                        disptile(x,y,spr,pCode[0xd800+16+idx]&0x20,pCode[0xd800+16+idx]&0x40,col);
                        p1942BackDirt[idxx]=spr|(col<<9);
                     }
                  }
                  idxx++;
               }
            }
            oldback=bb;
            scrl=(pCode[0xc802]+((pCode[0xc803]&0x01)<<8));
            xpos=256-scrl;
            if(xpos<0)
               xpos+=512;
            pWork=pBoard->pScreen;
            pWork2=p1942Background+0x2000+xpos;

            cpy1=512-xpos;
            cpy2=0;
            if(cpy1>=256)
               cpy1=256;
            else
               cpy2=256-cpy1;

            p1942BackOut2=pWork+cpy1;
            p1942BackIn2=p1942Background+0x2000;

            __asm__ __volatile__
            (
               ".align 4 \n"
//setup es
               "pushw   %%es  \n"
               "movw    %%ax,%%es \n"

               "movl    $224,%%edx \n"
//height loop
"1:\n"
//save copy2
               "pushl   %%ecx \n"
//double words
               "movl    %%ebx,%%ecx \n"
               "shrl    $2,%%ecx \n"
               "rep \n"
               "movsl \n"
//words
               "movl    %%ebx,%%ecx \n"
               "andl    $3,%%ecx \n"
               "shrl    $1,%%ecx \n"
               "jz      2f \n"
               "rep \n"
               "movsw \n"
"2:\n"
//byte
               "movl    %%ebx,%%ecx \n"
               "andl    $1,%%ecx \n"
               "jz      3f \n"
               "movsb \n"
"3:\n"
               "movl    $512,%%ecx \n"
               "subl    %%ebx,%%ecx \n"
               "addl    %%ecx,%%edi \n"
               "addl    %%ecx,%%esi \n"

//get cpy2 back
               "popl    %%ecx \n"
               "pushl   %%ecx \n"
//anything there ?
               "cmpl    $0,%%ecx \n"
               "je      6f \n"
//save 1st 'page'
               "pushl   %%ebx \n"
               "pushl   %%esi \n"
               "pushl   %%edi \n"
//setup 2nd 'page'
               "movl    %%ecx,%%ebx \n"
               "movl    _p1942BackIn2,%%esi \n"
               "movl    _p1942BackOut2,%%edi \n"
//double words
               "shrl    $2,%%ecx \n"
               "rep \n"
               "movsl \n"
//words
               "movl    %%ebx,%%ecx \n"
               "andl    $3,%%ecx \n"
               "shrl    $1,%%ecx \n"
               "jz      4f \n"
               "rep \n"
               "movsw \n"
"4:\n"
//byte
               "movl    %%ebx,%%ecx \n"
               "andl    $1,%%ecx \n"
               "jz      5f \n"
               "movsb \n"
"5:\n"
               "addl    $512,%%edi \n"
               "subl    %%ebx,%%edi \n"
               "addl    $512,%%esi \n"
               "subl    %%ebx,%%esi \n"
//save changes to 2nd page
               "movl    %%esi,_p1942BackIn2 \n"
               "movl    %%edi,_p1942BackOut2 \n"
//get back first page
               "popl    %%edi \n"
               "popl    %%esi \n"
               "popl    %%ebx \n"
"6:\n"
//end of height loop
               "popl    %%ecx \n"
               "decl    %%edx \n"
               "jnz     1b \n"
               "popw    %%es \n"
//outputs (clobbered inputs)
               : "=a" (dummy1),
               "=S" (dummy2),
               "=D" (dummy3),
               "=b" (dummy4),
               "=c" (dummy5)
 // inputs -
               : "0" (DataSeg),
               "1" (pWork2),
               "2" (pWork),
               "3" (cpy1),
               "4" (cpy2)
// registers modified
               :  "dx","cc", "memory"
            );
         }
         else
            fastclear();
//sprites
         transcol=15;
         for(idx=0xcc7c;idx>=0xcc00;idx-=4)
         {
            col=(pCode[idx+1]&0x0f);
            x=240-(pCode[idx+3]-((pCode[idx+1]&0x10)<<4));
            y=240-pCode[idx+2];

            if(x!=240&&y!=240)
            {
               nspr=nsa[(pCode[idx+1]&0xc0)>>6];
               y-=nspr<<4;
               spr=(pCode[idx]&0x7f)+((pCode[idx+1]&0x20)<<2)+((pCode[idx]&0x80)<<1)+nspr;
               for(si=0;si<=nspr;si++,spr--,y+=16)
                  sprblit(x,y,spr,col,FlipScreen,FlipScreen);
            }
         }
//chars
         pWork=pScreen;
         pWork2=&pCode[0xd000];
         pCol=&pCode[0xd400];
         transcol=0;
         for(y=0;y<30;y++)
         {
            prey=((31-y)<<3);
            for(x=0;x<32;x++,pWork2++,pCol++)
            {
               spr=*pWork2+((*pCol&0x80)<<1);
               if(spr!=48)
                  disptranschar(((31-x)<<3),prey,spr,*pCol&0x3f);
            }
         }
      }
   }
   else
   {
      bb=(pCode[0xc805]&0x03)<<5;
      if(FlipScreen)
      {
         if(background)
         {
//background
            idxx=0;
            for(idx=1023;idx>=0;idx--)
            {

               if(!(idx&0x10))
               {

                  spr=pCode[0xd800+idx]+((pCode[0xd800+idx+16]&0x80)<<1);
                  col=(pCode[0xd800+idx+16]&0x1f)|bb;
                  if(oldback!=bb||p1942BackDirt[idxx]!=(spr|(col<<9)))
                  {
                     x=(idx>>5);
                     {
                        y=(idx&0x1f);

                        flpx=(pCode[0xd810+idx]&0x40);
                        flpy=!(pCode[0xd810+idx]&0x20);

                        disptile(y,x,spr,flpx,flpy,col);
                        p1942BackDirt[idxx]=spr|(col<<9);
                     }
                  }
                  idxx++;
               }
            }

            oldback=bb;
            xpos=pCode[0xc802]+((pCode[0xc803]&0x01)<<8);
            pWork=pBoard->pScreen;
            pWork2=p1942Background+16+(xpos<<8);
            cpy1=512-xpos;


            __asm__ __volatile__
            (
               ".align 4 \n"
//setup es
               "pushw   %%es  \n"
               "movw    %%ax,%%es \n"

               "movl    $256,%%edx \n"
//height loop
         "1:\n"
               "movl    $56,%%ecx \n"
               "rep \n"
               "movsl \n"

               "addl    $512-224,%%edi \n"
               "addl    $256-224,%%esi \n"
//check for wrap
               "decl    %%ebx \n"
               "jnz     2f \n"
               "movl    _p1942Background,%%esi \n"
               "addl    $16,%%esi \n"
         "2:\n"
//end of height loop
               "decl    %%edx \n"
               "jnz     1b \n"
               "popw    %%es \n"

//outputs (clobbered inputs)
               : "=a" (dummy1),
               "=S" (dummy2),
               "=D" (dummy3),
               "=b" (dummy4)
// inputs -
               : "0" (DataSeg),
               "1" (pWork2),
               "2" (pWork),
               "3" (cpy1)
// registers modified
               :  "cx","dx","cc", "memory"
            );

         }
         else
            fastclear();
//sprites
         transcol=15;
         for(idx=0xcc7c;idx>=0xcc00;idx-=4)
         {
            col=(pCode[idx+1]&0x0f);
            x=(pCode[idx+3]-((pCode[idx+1]&0x10)<<4));
            y=247-pCode[idx+2];
            if(x>=-8&&y>=0&&y!=247)
            {
               nspr=nsa[(pCode[idx+1]&0xc0)>>6];
               y-=nspr<<4;
               spr=(pCode[idx]&0x7f)+((pCode[idx+1]&0x20)<<2)+((pCode[idx]&0x80)<<1)+nspr;
               for(si=0;si<=nspr;si++,spr--,y+=16)
                  sprblit(y,x,spr,col,FlipScreen,FlipScreen);
            }
         }
//chars
         pWork=pScreen;
         pWork2=&pCode[0xd000];
         pCol=&pCode[0xd400];
         transcol=0;
         for(y=0;y<30;y++)
         {
            prey=256-(y<<3);
            for(x=0;x<32;x++,pWork2++,pCol++)
            {
               spr=*pWork2+((*pCol&0x80)<<1);
               if(spr!=48)
                  disptranschar(prey,(x<<3),spr,*pCol&0x3f);
            }
         }
      }
      else
      {
         if(background)
         {
//background
            idxx=0;
            for(idx=1023;idx>=0;idx--)
            {
               if(!(idx&0x10))
               {
                  spr=pCode[0xd800+idx]+((pCode[0xd800+idx+16]&0x80)<<1);
                  col=(pCode[0xd800+idx+16]&0x1f)|bb;
                  if(oldback!=bb||p1942BackDirt[idxx]!=(spr|(col<<9)))
                  {
                     x=31-(idx>>5);
                     {
                        y=(idx&0x1f);
                        flpx=(pCode[0xd810+idx]&0x40);
                        flpy=(pCode[0xd810+idx]&0x20);

                        disptile(y,x,spr,flpx,flpy,col);
                        p1942BackDirt[idxx]=spr|(col<<9);
                     }
                  }
                  idxx++;
               }
            }

            oldback=bb;
            scrl=(pCode[0xc802]+((pCode[0xc803]&0x01)<<8));
            xpos=256-scrl;
            if(xpos<0)
               xpos+=512;
            pWork=pBoard->pScreen;
            pWork2=p1942Background+16+(xpos<<8);
            cpy1=512-xpos;
            if(cpy1>=256)
               cpy1=256;

            __asm__ __volatile__
            (
               ".align 4 \n"
//setup es
               "pushw   %%es  \n"
               "movw    %%ax,%%es \n"

               "movl    $256,%%edx \n"
//height loop
         "1:\n"
               "movl    $56,%%ecx \n"
               "rep \n"
               "movsl \n"

               "addl    $512-224,%%edi \n"
               "addl    $256-224,%%esi \n"
//check for wrap
               "decl    %%ebx \n"
               "jnz     2f \n"
               "movl    _p1942Background,%%esi \n"
               "addl    $16,%%esi \n"
         "2:\n"
//end of height loop
               "decl    %%edx \n"
               "jnz     1b \n"
               "popw    %%es \n"

//outputs (clobbered inputs)
               : "=a" (dummy1),
               "=S" (dummy2),
               "=D" (dummy3),
               "=b" (dummy4)
// inputs -
               : "0" (DataSeg),
               "1" (pWork2),
               "2" (pWork),
               "3" (cpy1)
// registers modified
               :  "cx","dx","cc", "memory"
            );
         }
         else
            fastclear();
//sprites
         transcol=15;
         for(idx=0xcc7c;idx>=0xcc00;idx-=4)
         {
            col=(pCode[idx+1]&0x0f);
            x=240-(pCode[idx+3]-((pCode[idx+1]&0x10)<<4));
            y=pCode[idx+2]+8;
            if(x!=240&&y!=240)
            {
               nspr=nsa[(pCode[idx+1]&0xc0)>>6];
               y+=nspr<<4;
               spr=(pCode[idx]&0x7f)+((pCode[idx+1]&0x20)<<2)+((pCode[idx]&0x80)<<1)+nspr;
               for(si=0;si<=nspr;si++,spr--,y-=16)
                  sprblit(y,x,spr,col,FlipScreen,FlipScreen);
            }
         }
//chars
         pWork=pScreen;
         pWork2=&pCode[0xd000];
         pCol=&pCode[0xd400];
         transcol=0;
         for(y=0;y<30;y++)
         {
            prey=(y<<3)+8;
            for(x=0;x<32;x++,pWork2++,pCol++)
            {
               spr=*pWork2+((*pCol&0x80)<<1);
               if(spr!=48)
                  disptranschar(prey,((31-x)<<3),spr,*pCol&0x3f);
            }
         }
      }
   }
}

void disptile(int x,int y,int value,int flipx,int flipy,int col)
{
   int dummy1,dummy2,dummy3;
   int x1,y1,flp1c,flp2c;
   int xmove,ymove;
   pBYTE pOut;
   pBYTE pIn;

   col<<=3;

   pIn=&Tiles[(value<<8)];

   xmove=1;

   if(realorient)
   {
      pOut=p1942Background+(x<<4)+(y<<13);


      if(flipy)
      {
         pOut+=0x1e00;
         ymove=-528;
      }
      else
         ymove=496;
   }
   else
   {
      pOut=p1942Background+(x<<4)+(y<<12);

      if(flipy)
      {
         pOut+=3840;
         ymove=-272;
      }
      else
         ymove=240;
   }

   if(flipx)
   {
      pOut+=15;
      xmove=-1;
      ymove+=32;
   }



   for(y1=0;y1<16;y1++)
   {
      for(x1=0;x1<16;x1++,pIn++)
      {
         *pOut=p1942tlkup[*pIn+col];
         pOut+=xmove;
      }
      pOut+=ymove;
   }

}



void _1942setpal(pBYTE pIn)
{
   int idx,col,plane;
   int mfact[]={0x0e,0x1f,0x43,0x8f};
   for(idx=0;idx<256;idx++)
   {
      outportb(0x3c8,idx);
      //red
      col=0;
      for(plane=0;plane<4;plane++)
         col+=(((*pIn>>plane)&0x01)*mfact[plane]);
      outportb(0x3c9,col>>2);
      //green
      col=0;
      for(plane=0;plane<4;plane++)
         col+=(((pIn[256]>>plane)&0x01)*mfact[plane]);
      outportb(0x3c9,col>>2);
      //blue
      col=0;
      for(plane=0;plane<4;plane++)
         col+=(((pIn[512]>>plane)&0x01)*mfact[plane]);
      outportb(0x3c9,col>>2);
      pIn++;
	}
   pIn+=512;
//char lookup
   for(idx=0;idx<256;idx++)
      collookups[0][idx]=*(pIn++)|0x80;
   collookups[0][0]=0;
//tile lookup
   for(idx=0;idx<256;idx++)
   {
      p1942tlkup[idx]=*pIn;
      p1942tlkup[idx+0x100]=*pIn+0x10;
      p1942tlkup[idx+0x200]=*pIn+0x20;
      p1942tlkup[idx+0x300]=*(pIn++)+0x30;
   }
//sprite lookup
   for(idx=0;idx<256;idx++)
   {
      collookups[1][idx]=*(pIn++)+0x40;
      if((collookups[1][idx]&15)==15)
         collookups[1][idx]=15;
   }

}
