#include "main.h"
#include "1943vid.h"
#include "globals.h"
#include "twk.h"
#include "galvid.h"

static int chon=1;
static pBYTE p1943BackGround;
static pBYTE p1943BackGround2;
static pBYTE p1943Plane1;
static pBYTE p1943Plane2;
static pBYTE p1943Plane2Base;
static int _1943flip;

static pBYTE p1943CodeBase[8];
static int Cur1943Bank=-1;


static unsigned int _1943dirt1[9][9];
static unsigned int _1943dirt2[9][9];

static _1943SPRITE _1943OverSprites[256];

static int No1943Overs;


void _1943int(void)
{
   mz80int(0xff);
}

void init1943(void)
{
   int i;

//background info
   p1943BackGround=myalloc(0x10000);
   p1943BackGround2=p1943BackGround+0x8000;
//temp planes
   p1943Plane1=calloc(512*512,1);
//lazy hack for flipped/rotated x scrolls
   p1943Plane2Base=calloc(544*512,1);
   p1943Plane2=p1943Plane2Base+(32<<9);

   clear1943planes();
//setup bank switches
   for(i=0;i<8;i++)
   {
      if(!i)
      {
         p1943CodeBase[i]=pCode;
      }
      else
      {
         p1943CodeBase[i]=calloc(0x10000,1);
         memcpy(p1943CodeBase[i],pCode,0x8000);
      }
      memcpy(&p1943CodeBase[i][0x8000],&pCode[0x10000+(0x4000*i)],0x4000);
   }
}

void clear1943planes(void)
{
   int i;
   for(i=0;i<9;i++)
   {
      memset(&_1943dirt1[i],-1,sizeof(int)*9);
      memset(&_1943dirt2[i],-1,sizeof(int)*9);
   }
}

void clear1943(void)
{
   int i;
   myfree(p1943BackGround);
   myfree(p1943Plane1);
   myfree(p1943Plane2Base);
   for(i=1;i<8;i++)
      myfree(p1943CodeBase[i]);

}

void _1943decodegfx(pBYTE pIn,int nType)
{
   pBYTE pWork;
   pWork=&pIn[0x98000];
   memcpy(p1943BackGround,pWork,0x10000);
}

void _1943setpal(pBYTE pIn)
{
   int idx,rem255,col;
   int bit0,bit1,bit2,bit3;
   static PALETTE _1943pal[256];

   for(idx=0;idx<256;idx++)
   {
      outportb(0x3c8,idx);

      bit0=(pIn[0]&0x01)*0x0e;
      bit1=((pIn[0]>>1)&0x01)*0x1f;
      bit2=((pIn[0]>>2)&0x01)*0x43;
      bit3=((pIn[0]>>3)&0x01)*0x8f;
      _1943pal[idx].r=(bit0+bit1+bit2+bit3)>>2;
      outportb(0x3c9,_1943pal[idx].r);

      bit0=(pIn[256]&0x01)*0x0e;
      bit1=((pIn[256]>>1)&0x01)*0x1f;
      bit2=((pIn[256]>>2)&0x01)*0x43;
      bit3=((pIn[256]>>3)&0x01)*0x8f;
      _1943pal[idx].g=(bit0+bit1+bit2+bit3)>>2;
      outportb(0x3c9,_1943pal[idx].g);

      bit0=(pIn[512]&0x01)*0x0e;
      bit1=((pIn[512]>>1)&0x01)*0x1f;
      bit2=((pIn[512]>>2)&0x01)*0x43;
      bit3=((pIn[512]>>3)&0x01)*0x8f;
      _1943pal[idx].b=(bit0+bit1+bit2+bit3)>>2;
      outportb(0x3c9,_1943pal[idx].b);

      pIn++;
	}
//remap 255 - as it's used by the UI
   rem255=remapcolour(255,_1943pal,256);

//lookups for characters
   pIn+=512;
   for(idx=0;idx<128;idx++)
   {
      col=*(pIn++)+64;
      if(col==255)
         col=rem255;
      collookups[0][idx]=col;
   }


   pIn+=128;
//foreground tiles
   for(idx=0;idx<256;idx++)
	{
      if(!(idx&0x0f))
         collookups[1][idx]=0;
		else
      {
         col=pIn[0]+16*(pIn[256]&0x03);
         if(col==255)
            col=rem255;
         collookups[1][idx]=col;
      }
      pIn++;
	}
//background tiles
   pIn+=256;
   for(idx=0;idx<256;idx++)
	{
      col=pIn[0]+16*(pIn[256]&0x03);
      if(col==255)
         col=rem255;
      collookups[2][idx]=col;
      pIn++;
	}
//sprites
   pIn+=256;
   for(idx=0;idx<256;idx++)
   {
      if(!(idx&0x0f))
         collookups[3][idx]=0;
      else
      {
         col=pIn[0]+16*(pIn[256]&0x07)+128;
         if(col==255)
            col=rem255;
         collookups[3][idx]=col;
      }
      pIn++;
   }
}

void update1943scr(void)
{
   pBYTE pWork2;
   pBYTE pCol;
   int x,y,prey,spr,attr,col;
   int bity1,bity2,bitx2;
   int idx;
   unsigned int dirtval;
   int b1,b2,obj;
   int scrolly;
   int scrolly2;
   int top,y2;

//active planes
   b2=pCode[0xd806]&0x10;
   b1=pCode[0xd806]&0x20;
   obj=pCode[0xd806]&0x40;

//over sprite totals
   No1943Overs=0;

//scroll registers
   scrolly=pCode[0xd803]|(pCode[0xd804]<<8);
   scrolly2=pCode[0xd800]|(pCode[0xd801]<<8);

   if(realorient)
   {


      idx=(((scrolly>>5)+8)<<4);
      top=(scrolly>>5)%9;
      bity1=((top<<5)-(scrolly&0x1f));

   //scrolling background
      if(b1)
      {
         if(FlipScreen)
         {
            for(y=0;y<9;y++)
            {
               idx&=0x7fff;
               y2=(y+top)%9;
               prey=(8-y2)<<5;

               for(x=0;x<8;x++)
               {
                  spr=p1943BackGround2[idx+(x<<1)];
                  attr=p1943BackGround2[idx+(x<<1)+1];
                  dirtval=spr|(attr<<16);
                  if(_1943dirt1[y2][x]!=dirtval)
                  {
                     col=(attr&0x3c)>>2;
                     disp1943tile(p1943Plane1,prey,x<<5,spr,col,!(attr&0x40),(attr&0x80),2,-1);
                     _1943dirt1[y2][x]=dirtval;
                  }
               }
               idx-=0x10;
            }
         }
         else
         {
            for(y=0;y<9;y++)
            {
               idx&=0x7fff;
               y2=(y+top)%9;
               prey=y2<<5;

               for(x=0;x<8;x++)
               {
                  spr=p1943BackGround2[idx+(x<<1)];
                  attr=p1943BackGround2[idx+(x<<1)+1];
                  dirtval=spr|(attr<<16);
                  if(_1943dirt1[y2][x]!=dirtval)
                  {
                     col=(attr&0x3c)>>2;
                     disp1943tile(p1943Plane1,prey,((7-x)<<5),spr,col,(attr&0x40),!(attr&0x80),2,-1);
                     _1943dirt1[y2][x]=dirtval;
                  }
               }
               idx-=0x10;
            }
         }
      }

      idx=(((scrolly2>>5)+8)<<4)+((pCode[0xd802]>>5)<<1);

      if (pCode[0xd802]&0x80)
         idx-=0x10;


      top=(scrolly2>>5)%9;
      bity2=((top<<5)-(scrolly2&0x1f));
   //scrolling foreground
      if(b2)
      {
         if(FlipScreen)
         {
            for(y=0;y<9;y++)
            {
               y2=(y+top)%9;
               prey=(8-y2)<<5;
               idx&=0x7fff;
               for(x=0;x<8;x++)
               {
                  spr=p1943BackGround[idx+(x<<1)];
                  attr=p1943BackGround[idx+(x<<1)+1];
                  spr|=((attr&1)<<8);
                  dirtval=spr|(attr<<16);
                  if(_1943dirt2[y2][x]!=dirtval)
                  {
                     col=(attr&0x3c)>>2;
                     disp1943tile(p1943Plane2,prey,(x<<5),spr+128,col,!(attr&0x40),(attr&0x80),1,128);
                     _1943dirt2[y2][x]=dirtval;
                  }
               }
               idx-=0x10;
            }
         }
         else
         {
            for(y=0;y<9;y++)
            {
               y2=(y+top)%9;
               prey=(y2)<<5;
               idx&=0x7fff;
               for(x=0;x<8;x++)
               {
                  spr=p1943BackGround[idx+(x<<1)];
                  attr=p1943BackGround[idx+(x<<1)+1];
                  spr|=((attr&1)<<8);
                  dirtval=spr|(attr<<16);
                  if(_1943dirt2[y2][x]!=dirtval)
                  {
                     col=(attr&0x3c)>>2;
                     disp1943tile(p1943Plane2,prey,((7-x)<<5),spr+128,col,(attr&0x40),!(attr&0x80),1,128);
                     _1943dirt2[y2][x]=dirtval;
                  }
               }
               idx-=0x10;
            }
         }
      }

      bitx2=pCode[0xd802]&0x1f;


   //draw backgrounds
      if(b1||b2)
         copy1943backs(bity1,bity2,bitx2,b1,b2,obj);
      else
         fastclear();
   //draw over sprites
      if(obj)
      {
         for(idx=0;idx<No1943Overs;idx++)
            sprblitlk(_1943OverSprites[idx].x,_1943OverSprites[idx].y,
                           _1943OverSprites[idx].spr,_1943OverSprites[idx].color,FlipScreen,FlipScreen,3,4,0);
      }


   //draw foreground characters
      if (chon)
      {
         pWork2=&pCode[0xd020];
         pCol=&pCode[0xd420];
         transcol=79;
         if(FlipScreen)
         {
            for(y=2;y<30;y++)
            {
               prey=(y<<3)-8;
               for(x=0;x<32;x++,pWork2++,pCol++)
               {
                  spr=*pWork2|((*pCol&0xe0)<<3);
                  if(spr!=36)
                     charblitlktrans((x<<3),prey,spr,(*pCol)&0x1f,0,2);
               }
            }
         }
         else
         {
            for(y=2;y<30;y++)
            {
               prey=256-(y<<3);
               for(x=0;x<32;x++,pWork2++,pCol++)
               {
                  spr=*pWork2|((*pCol&0xe0)<<3);
                  if(spr!=36)
                     charblitlktrans(248-(x<<3),prey,spr,(*pCol)&0x1f,0,2);
               }
            }
         }
         transcol=0;
      }
   }
   else
   {

      idx=(((scrolly>>5)+8)<<4);
      top=(scrolly>>5)%9;
      bity1=((top<<5)-(scrolly&0x1f));

      if(FlipScreen)
      {
         if(b1)
         {
            for(y=0;y<9;y++)
            {
               idx&=0x7fff;
               y2=(y+top)%9;
               prey=(8-y2)<<5;

               for(x=0;x<8;x++)
               {
                  spr=p1943BackGround2[idx+(x<<1)];
                  attr=p1943BackGround2[idx+(x<<1)+1];
                  dirtval=spr|(attr<<16);
                  if(_1943dirt1[y2][x]!=dirtval)
                  {
                     col=(attr&0x3c)>>2;
                     disp1943tile(p1943Plane1,((7-x)<<5),prey,spr,col,(attr&0x80),!(attr&0x40),2,-1);
                     _1943dirt1[y2][x]=dirtval;
                  }
               }
               idx-=0x10;
            }
         }
      }
      else
      {
   //scrolling background
         if(b1)
         {
            for(y=0;y<9;y++)
            {
               idx&=0x7fff;
               y2=(y+top)%9;
               prey=y2<<5;

               for(x=0;x<8;x++)
               {
                  spr=p1943BackGround2[idx+(x<<1)];
                  attr=p1943BackGround2[idx+(x<<1)+1];
                  dirtval=spr|(attr<<16);
                  if(_1943dirt1[y2][x]!=dirtval)
                  {
                     col=(attr&0x3c)>>2;
                     disp1943tile(p1943Plane1,x<<5,prey,spr,col,!(attr&0x80),attr&0x40,2,-1);
                     _1943dirt1[y2][x]=dirtval;
                  }
               }
               idx-=0x10;
            }
         }
      }

      idx=(((scrolly2>>5)+8)<<4)+((pCode[0xd802]>>5)<<1);

      if (pCode[0xd802]&0x80)
         idx-=0x10;


      top=(scrolly2>>5)%9;
      bity2=((top<<5)-(scrolly2&0x1f));
   //scrolling foreground
      if(b2)
      {
         if(FlipScreen)
         {
            for(y=0;y<9;y++)
            {
               y2=(y+top)%9;
               prey=(8-y2)<<5;
               idx&=0x7fff;
               for(x=0;x<8;x++)
               {
                  spr=p1943BackGround[idx+(x<<1)];
                  attr=p1943BackGround[idx+(x<<1)+1];
                  spr|=((attr&1)<<8);
                  dirtval=spr|(attr<<16);
                  if(_1943dirt2[y2][x]!=dirtval)
                  {
                     col=(attr&0x3c)>>2;
                     disp1943tile(p1943Plane2,((7-x)<<5),prey,spr+128,col,(attr&0x80),!(attr&0x40),1,128);
                     _1943dirt2[y2][x]=dirtval;
                  }
               }
               idx-=0x10;
            }
         }
         else
         {
            for(y=0;y<9;y++)
            {
               y2=(y+top)%9;

               prey=(y2)<<5;
               idx&=0x7fff;
               for(x=0;x<8;x++)
               {
                  spr=p1943BackGround[idx+(x<<1)];
                  attr=p1943BackGround[idx+(x<<1)+1];
                  spr|=((attr&1)<<8);
                  dirtval=spr|(attr<<16);
                  if(_1943dirt2[y2][x]!=dirtval)
                  {
                     col=(attr&0x3c)>>2;
                     disp1943tile(p1943Plane2,(x<<5),prey,spr+128,col,!(attr&0x80),attr&0x40,1,128);
                     _1943dirt2[y2][x]=dirtval;
                  }
               }
               idx-=0x10;
            }
         }
      }

      bitx2=pCode[0xd802]&0x1f;
   //draw backgrounds
      if(b1||b2)
         copy1943backs(bity1,bity2,bitx2,b1,b2,obj);
      else
         fastclear();
   //draw over sprites
      if(obj)
      {
         for(idx=0;idx<No1943Overs;idx++)
            sprblitlk(_1943OverSprites[idx].x,_1943OverSprites[idx].y,
                           _1943OverSprites[idx].spr,_1943OverSprites[idx].color,FlipScreen,FlipScreen,3,4,0);
      }

   //draw foreground characters
      if (chon)
      {
         pWork2=&pCode[0xd020];
         pCol=&pCode[0xd420];
         transcol=79;
         if(FlipScreen)
         {
            for(y=2;y<30;y++)
            {
               prey=264-(y<<3);
               for(x=0;x<32;x++,pWork2++,pCol++)
               {
                  spr=*pWork2|((*pCol&0xe0)<<3);
                  if(spr!=36)
                     charblitlktrans(prey,(x<<3),spr,(*pCol)&0x1f,0,2);
               }
            }
         }
         else
         {
            for(y=2;y<30;y++)
            {
               prey=(y<<3);
               for(x=0;x<32;x++,pWork2++,pCol++)
               {
                  spr=*pWork2|((*pCol&0xe0)<<3);
                  if(spr!=36)
                     charblitlktrans(prey,248-(x<<3),spr,(*pCol)&0x1f,0,2);
               }
            }
         }
         transcol=0;
      }
   }
}


UINT8 _1943prot(UINT32 offset,struct MemoryReadByte * mrb)
{
   mz80GetContext(&context[0]);
   return (context[0].z80bc.bc>>8);
}




void _1943bank(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{

   int newbank,flipper;

   chon=value&0x80;
   newbank=(value&0x1c)>>2;

   flipper=value>>6;

   if(_1943flip!=flipper)
   {
      flipscreenw(offset,flipper,mwb);
      _1943flip=flipper;
      clear1943planes();
   }

   if(Cur1943Bank!=newbank)
   {
//move bytes which mz80 writes directy to the code base
      if(Cur1943Bank!=-1)
         fastcopy(&p1943CodeBase[newbank][0xe800],&p1943CodeBase[Cur1943Bank][0xe800],0x10);

      z80Base=p1943CodeBase[newbank];
      Cur1943Bank=newbank;
   }
}



void disp1943tile(pBYTE pDest,int x,int y,int value,BYTE col,int flipx,int flipy,int lkup,int blnkval)
{
   int x1,y1,dummy1,dummy2,dummy3,temp;
   int ymove,xmove,precol;
   pBYTE pWork;
   pBYTE pWork2;
   pBYTE lk;

   pWork=pDest+x+(y<<9);
//check for easy blank tile
   if(value==blnkval)
   {

      int *out=(int *)pWork;
      for(y=0;y<32;y++)
      {
         *(out++)=0;
         *(out++)=0;
         *(out++)=0;
         *(out++)=0;
         *(out++)=0;
         *(out++)=0;
         *(out++)=0;
         *out=0;
         out+=121;
      }
      return;
   }

   pWork2=&BigSprites[(value<<10)];


   precol=col<<4;

   lk=collookups[lkup];

   xmove=1;


   if(flipy)
   {
      pWork+=0x3e00;
      ymove=-0x220;
   }
   else
      ymove=0x1e0;


   if(flipx)
   {
      pWork+=31;
      xmove=-1;
      ymove+=64;
   }

   for(y1=0;y1<32;y1++)
   {
      for(x1=0;x1<32;x1++,pWork2++)
      {
         *pWork=lk[(*pWork2)|precol];
         pWork+=xmove;
      }
      pWork+=ymove;
   }
}

void copy1943backs(int bity1,int bity2,int bitx2,int b1,int b2,int obj)
{
   pBYTE pWork1;
   pBYTE pWork2;
   int x,y,idx,spr,color,prey;
   int frst,rem;

   if(!background)
   {
      fastclear();
      b1=b2=0;
   }

   if(realorient)
   {
      if(b1)
      {
         int savebit;
         if(FlipScreen)
            bity1=288-bity1;
         else
            bity1+=32;

         if(bity1>=288)
            bity1-=288;

         pWork2=pScreen+0x6020;

         if(bity1<33)
         {
            pWork1=p1943Plane1+bity1+(16<<9);
            for(y=0;y<224;y++)
            {
               fastcopy(pWork2,pWork1,64);
               pWork2+=512;
               pWork1+=512;
            }
         }
         else
         {
            frst=288-bity1;
            rem=256-frst;

            pWork1=p1943Plane1+bity1+(16<<9);
            for(y=0;y<224;y++)
            {
               memcpy(pWork2,pWork1,frst);
               memcpy(pWork2+frst,pWork1-bity1,rem);
               pWork2+=512;
               pWork1+=512;
            }

         }
      }

//sort out sprite priority lists
      if(obj)
      {
         if(FlipScreen)
         {
            for(idx=0xffe0;idx>=0xf000;idx-=32)
            {
               spr=pCode[idx]+((pCode[idx+1]&0xe0)<<3);
               if(spr)
               {
                  x=pCode[idx+3]-((pCode[idx+1]&0x10)<<4);
                  y=pCode[idx+2];
                  if(x>-16&&y>0)
                  {
                     color=pCode[idx+1]&0x0f;
                     if(color==0x0a||color==0x0b)
                     {
                        sprblitlk(x,y,spr,color,1,1,3,4,0);
                     }
                     else
                     {
                        _1943OverSprites[No1943Overs].x=x;
                        _1943OverSprites[No1943Overs].y=y;
                        _1943OverSprites[No1943Overs].spr=spr;
                        _1943OverSprites[No1943Overs++].color=color;
                     }
                  }
               }
            }
         }
         else
         {
            for(idx=0xffe0;idx>=0xf000;idx-=32)
            {
               spr=pCode[idx]+((pCode[idx+1]&0xe0)<<3);
               if(spr)
               {
                  x=pCode[idx+3]-((pCode[idx+1]&0x10)<<4);
                  y=pCode[idx+2];
                  if(x>-16&&y>0)
                  {
                     color=pCode[idx+1]&0x0f;
                     if(color==0x0a||color==0x0b)
                     {
                        sprblitlk(239-x,239-y,spr,color,0,0,3,4,0);
                     }
                     else
                     {
                        _1943OverSprites[No1943Overs].x=239-x;
                        _1943OverSprites[No1943Overs].y=239-y;
                        _1943OverSprites[No1943Overs].spr=spr;
                        _1943OverSprites[No1943Overs++].color=color;
                     }
                  }
               }
            }
         }
      }

      if(b2)
      {
         int savebit;
         int xx,x2;
         if(FlipScreen)
         {
            bity2=288-bity2;
            xx=bitx2;
            x2=16;
         }
         else
         {
            bity2+=32;
            xx=16-bitx2;
            x2=0;
         }

         if(bity2>=288)
            bity2-=288;
         pWork2=pScreen+0x6020;
         savebit=bity2;
         for(y=0;y<224;y++)
         {
            prey=(y+xx+x2)<<9;

            bity2=savebit;
            pWork1=p1943Plane2+bity2+prey;


            for(x=0;x<256;x++,pWork1++,pWork2++)
            {
               if(bity2==288)
               {
                  bity2=0;
                  pWork1=p1943Plane2+bity2+prey;
               }

               if(*pWork1)
                  *pWork2=*pWork1;
               bity2++;
            }
            pWork2+=256;
         }
      }
   }
   else
   {
      if(b1)
      {
         if(FlipScreen)
            bity1=288-bity1;
         else
            bity1+=32;

         if(bity1>=288)
            bity1-=288;
         pWork1=p1943Plane1+16+(bity1<<9);
         pWork2=pScreen+0x4038;
         for(y=0;y<256;y++)
         {
            if(bity1==288)
            {
               bity1=0;
               pWork1=p1943Plane1+16;
            }
            fastcopy(pWork2,pWork1,56);
            bity1++;
            pWork1+=512;
            pWork2+=512;
         }
      }

//sort out sprite priority lists
      if(obj)
      {
         if(FlipScreen)
         {
            for(idx=0xffe0;idx>=0xf000;idx-=32)
            {
               spr=pCode[idx]+((pCode[idx+1]&0xe0)<<3);
               if(spr)
               {
                  x=pCode[idx+3]-((pCode[idx+1]&0x10)<<4);
                  y=pCode[idx+2];
                  if(x>-16&&y>0)
                  {
                     color=pCode[idx+1]&0x0f;
                     if(color==0x0a||color==0x0b)
                     {

                        sprblitlk(248-y,x,spr,color,1,1,3,4,0);
                     }
                     else
                     {
                        _1943OverSprites[No1943Overs].x=248-y;
                        _1943OverSprites[No1943Overs].y=x;
                        _1943OverSprites[No1943Overs].spr=spr;
                        _1943OverSprites[No1943Overs++].color=color;
                     }
                  }
               }
            }
         }
         else
         {
            for(idx=0xffe0;idx>=0xf000;idx-=32)
            {
               spr=pCode[idx]+((pCode[idx+1]&0xe0)<<3);
               if(spr)
               {
                  x=pCode[idx+3]-((pCode[idx+1]&0x10)<<4);
                  y=pCode[idx+2];
                  if(x>-16&&y>0)
                  {
                     color=pCode[idx+1]&0x0f;
                     if(color==0x0a||color==0x0b)
                     {
                        sprblitlk(y+8,239-x,spr,color,0,0,3,4,0);
                     }
                     else
                     {
                        _1943OverSprites[No1943Overs].x=y+8;
                        _1943OverSprites[No1943Overs].y=239-x;
                        _1943OverSprites[No1943Overs].spr=spr;
                        _1943OverSprites[No1943Overs++].color=color;
                     }
                  }
               }
            }
         }
      }


      if(b2)
      {
         int xx;
         if(FlipScreen)
         {
            bity2=288-bity2;
            bitx2=16-bitx2;
            xx=0;
         }
         else
         {
            bity2+=32;
            xx=16;
         }



         if(bity2>=288)
            bity2-=288;




         pWork1=p1943Plane2+bitx2+xx+(bity2<<9);

         pWork2=pScreen+0x4038;


         for(y=0;y<256;y++)
         {
            if(bity2==288)
            {
               bity2=0;
               pWork1=p1943Plane2+xx+bitx2;
            }


            bity2++;
            for(x=0;x<224;x++,pWork1++,pWork2++)
            {
               if(*pWork1)
                  *pWork2=*pWork1;
            }
            pWork1+=288;
            pWork2+=288;
         }
      }
   }
}
