#include "main.h"
#include "dkvid.h"
#include "globals.h"
#include "blit.h"
#include "twk.h"
#include "pacvid.h"
#include "dksnd.h"

static pBYTE pCLookup;
static int pbank;


void initdk(void)
{
   pbank=0;
   blnkchar=16;
   colmask=63;
}

void cleardk(void)
{
}

void dkint(void)
{
   if(pCode[0x7d84])
      mz80nmi();
}


void dkpbankwrite(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   int work;

   WRITE_MEM

   work=offset-mwb->lowAddr;

   if(value&1)
      pbank|=1<<work;
   else
      pbank&=~(1<<work);

}

void dkjrupdatescreen(void)
{
   dkjrupdatesound();
   dkgenupdatescreen();
}

void dkupdatescreen(void)
{
   dkupdatesound();
   dkgenupdatescreen();
}

void dkgenupdatescreen(void)
{
   int x,y,idx,prey1,prey2;
   int col,bk,out,precol,flipx,flipy;
   pBYTE pWork1;
   pBYTE pWork2;


   bk=(pCode[0x7c80]<<8);
   precol=(pbank<<4);

   if(realorient)
   {
      pWork1=&pCode[0x7400+64];
      pWork2=&pCode[0x10400+(0x800*pbank)+64];

      if(FlipScreen)
      {
         for(y=2;y<30;y++)
         {
            prey2=y<<5;
            prey1=y<<3;
            for(x=0;x<32;x++,pWork1++,pWork2++)
            {
               out=(*pWork1)|bk;
               dispchar(280-((x+2)<<3),248-prey1,out,(*pWork2)&0x3f);
            }
         }


         for(idx=0x6900;idx<0x6a80;idx+=4)
         {
            y=pCode[idx]-7;
            if(y>0&&y<239)
            {
               x=264-pCode[idx+3];
               col=(pCode[idx+2]&0x0f)+precol;
               flipx=!(pCode[idx+2]&0x80);
               flipy=!(pCode[idx+1]&0x80);
               sprblit(x,y,pCode[idx+1]&0x7f,col&0x3f,flipx,flipy);
            }
         }
      }
      else
      {
         for(y=2;y<30;y++)
         {
            prey2=y<<5;
            prey1=y<<3;
            for(x=0;x<32;x++,pWork1++,pWork2++)
            {
               out=(*pWork1)|bk;
               dispchar(x<<3,prey1,out,(*pWork2)&0x3f);
            }
         }

         for(idx=0x6900;idx<0x6a80;idx+=4)
         {
            y=(240-pCode[idx])+7;
            if(y>7)
            {
               x=pCode[idx+3]-8;
               col=(pCode[idx+2]&0x0f)+precol;
               flipx=pCode[idx+2]&0x80;
               flipy=pCode[idx+1]&0x80;
               sprblit(x,y,pCode[idx+1]&0x7f,col&0x3f,flipx,flipy);
            }
         }
      }
   }
   else
   {
      pWork1=&pCode[0x7400+64];
      pWork2=&pCode[0x10400+(0x800*pbank)+64];

      if(FlipScreen)
      {
         for(y=2;y<30;y++)
         {
            prey1=(y<<3)+7;
            prey2=y<<5;

            for(x=0;x<32;x++,pWork1++,pWork2++)
            {
               out=(*pWork1)|bk;
               dispchar(prey1,264-(x<<3),out,(*pWork2)&0x3f);
            }
         }

         for(idx=0x6900;idx<0x6a80;idx+=4)
         {
            x=264-pCode[idx+3];

            if(x<257)
            {
               y=254-pCode[idx];
               col=(pCode[idx+2]&0x0f)+precol;
               flipx=!(pCode[idx+1]&0x80);
               flipy=!(pCode[idx+2]&0x80);
               sprblit(y,x,pCode[idx+1]&0x7f,col&0x3f,flipx,flipy);
            }
         }
      }
      else
      {
         for(y=2;y<30;y++)
         {
            prey1=255-(y<<3);
            prey2=(31-y);

            for(x=0;x<32;x++,pWork1++,pWork2++)
            {
               out=(*pWork1)|bk;
               dispchar(prey1,x<<3,(*pWork1)|bk,(*pWork2)&0x3f);
            }

         }
         for(idx=0x6900;idx<0x6a80;idx+=4)
         {
            x=pCode[idx+3]-8;
            if(x>7)
            {
               y=(pCode[idx]);
               col=(pCode[idx+2]&0x0f)+precol;
               flipx=pCode[idx+1]&0x80;
               flipy=pCode[idx+2]&0x80;
               sprblit(y,x,pCode[idx+1]&0x7f,col&0x3f,flipx,flipy);
            }
         }
      }
   }
}



void dkdecodegfx(pBYTE pIn,int nType)
{
   int cindex,x;
//flatten out the character colour data
   for(cindex=0;cindex<1024;cindex++)
      for(x=0;x<4;x++)
         pCode[0x10400+(0x800*x)+cindex]=(pCLookup[(cindex&0x1f)+((cindex>>7)<<5)]&0x0f)+(x<<4);
}


void dksetpal(pBYTE pIn)
{
   int idx,bit0,bit1,bit2;

   for(idx=0;idx<256;idx++)
   {

      outportb(0x3c8,idx);

      bit0=((pIn[256]>>1)&1)*0x21;
      bit1=((pIn[256]>>2)&1)*0x47;
      bit2=((pIn[256]>>3)&1)*0x97;

      outportb(0x3c9,(255-(bit0+bit1+bit2))>>2);

      bit0=((*pIn>>2)&1)*0x21;
      bit1=((*pIn>>3)&1)*0x47;
      bit2=(pIn[256]&1)*0x97;

      outportb(0x3c9,(255-(bit0+bit1+bit2))>>2);

      bit0=(*pIn&1)*0x55;
      bit1=((*pIn>>1)&1)*0xaa;


      outportb(0x3c9,(255-(bit0+bit1))>>2);
      pIn++;

	}

   pIn+=256;
   pCLookup=pIn;
}

UINT8 dkinp2(UINT32 offset, struct MemoryReadByte *mrb)
{
   return pCode[0x10001];
}

