#include "main.h"
#include "gsmkevid.h"
#include "1943vid.h"
#include "globals.h"
#include "twk.h"
#include "galvid.h"

static int chon=1;
static pBYTE pGSmokeBackGround;
static pBYTE pGSmokePlaneBase;
static pBYTE pGSmokePlane;
static int gsmokeflip;

static pBYTE pGSmokeCodeBase[4];
static int CurGSmokeBank=-1;

static unsigned int gsmokedirt[9][9];


void gsmokeint(void)
{
   mz80int(0xff);
}

void initgsmoke(void)
{
   int i;

//background info
   pGSmokeBackGround=myalloc(0x8000);
//temp plane
//lazy hack for flipped/rotated x scrolls
   pGSmokePlaneBase=calloc(544*512,1);
   pGSmokePlane=pGSmokePlaneBase+(32<<9);

   cleargsmokeplanes();
//setup bank switches
   for(i=0;i<4;i++)
   {
      if(!i)
      {
         pGSmokeCodeBase[i]=pCode;
      }
      else
      {
         pGSmokeCodeBase[i]=calloc(0x10000,1);
         memcpy(pGSmokeCodeBase[i],pCode,0x8000);
      }
      memcpy(&pGSmokeCodeBase[i][0x8000],&pCode[0x10000+(0x4000*i)],0x4000);
   }
}

void cleargsmokeplanes(void)
{
   int i;
   for(i=0;i<9;i++)
      memset(&gsmokedirt[i],-1,sizeof(int)*9);
}

void cleargsmoke(void)
{
   int i;
   myfree(pGSmokeBackGround);
   myfree(pGSmokePlaneBase);
   for(i=1;i<4;i++)
      myfree(pGSmokeCodeBase[i]);

}

void gsmokedecodegfx(pBYTE pIn,int nType)
{
   pBYTE pWork;
   pWork=&pIn[0x84000];
   memcpy(pGSmokeBackGround,pWork,0x8000);
}

void gsmokesetpal(pBYTE pIn)
{
   int idx,rem255,col;
   int bit0,bit1,bit2,bit3;
   static PALETTE gsmokepal[256];


   for(idx=0;idx<256;idx++)
   {
      outportb(0x3c8,idx);

      bit0=(pIn[0]&0x01)*0x0e;
      bit1=((pIn[0]>>1)&0x01)*0x1f;
      bit2=((pIn[0]>>2)&0x01)*0x43;
      bit3=((pIn[0]>>3)&0x01)*0x8f;
      gsmokepal[idx].r=(bit0+bit1+bit2+bit3)>>2;
      outportb(0x3c9,gsmokepal[idx].r);

      bit0=(pIn[256]&0x01)*0x0e;
      bit1=((pIn[256]>>1)&0x01)*0x1f;
      bit2=((pIn[256]>>2)&0x01)*0x43;
      bit3=((pIn[256]>>3)&0x01)*0x8f;
      gsmokepal[idx].g=(bit0+bit1+bit2+bit3)>>2;
      outportb(0x3c9,gsmokepal[idx].g);

      bit0=(pIn[512]&0x01)*0x0e;
      bit1=((pIn[512]>>1)&0x01)*0x1f;
      bit2=((pIn[512]>>2)&0x01)*0x43;
      bit3=((pIn[512]>>3)&0x01)*0x8f;
      gsmokepal[idx].b=(bit0+bit1+bit2+bit3)>>2;
      outportb(0x3c9,gsmokepal[idx].b);

      pIn++;
	}
//remap 255 - as it's used by the UI
   rem255=remapcolour(255,gsmokepal,256);

//lookups for characters
   pIn+=512;


   for(idx=0;idx<128;idx++)
   {
      col=*(pIn++)+64;
      if(col==255)
         col=rem255;
      collookups[0][idx]=col;
   }



   pIn+=128;
//foreground tiles
   for(idx=0;idx<256;idx++)
	{
      if(!(idx&0x0f))
         collookups[1][idx]=0;
		else
      {
         col=pIn[0]+16*(pIn[256]&0x03);
         if(col==255)
            col=rem255;
         collookups[1][idx]=col;
      }
      pIn++;
	}

//sprites
   pIn+=256;
   for(idx=0;idx<256;idx++)
   {
      if(!(idx&0x0f))
         collookups[3][idx]=0;
      else
      {
         col=pIn[0]+16*(pIn[256]&0x07)+128;
         if(col==255)
            col=rem255;
         collookups[3][idx]=col;
      }
      pIn++;
   }

}

void updategsmokescr(void)
{
   pBYTE pWork2;
   pBYTE pCol;
   int x,y,prey,spr,attr,col;
   int bity1,bity2,bitx2;
   int idx;
   unsigned int dirtval;
   int b2,obj,bcheck;
   int scrolly;
   int scrolly2;
   int top,y2;


   b2=pCode[0xd806]&0x10;
   obj=pCode[0xd806]&0x20;
   bcheck=(b2&&background);



//scroll registers
   scrolly=pCode[0xd803]|(pCode[0xd804]<<8);
   scrolly2=pCode[0xd800]|(pCode[0xd801]<<8);

   if(realorient)
   {




      idx=(((scrolly2>>5)+8)<<4)+((pCode[0xd802]>>5)<<1);

      if (pCode[0xd802]&0x80)
         idx-=0x10;


      top=(scrolly2>>5)%9;
      bity2=((top<<5)-(scrolly2&0x1f));
   //scrolling background

      if(bcheck)
      {
         if(FlipScreen)
         {
            for(y=0;y<9;y++)
            {
               y2=(y+top)%9;
               prey=(8-y2)<<5;
               idx&=0x7fff;
               for(x=0;x<8;x++)
               {
                  spr=pGSmokeBackGround[idx+(x<<1)];
                  attr=pGSmokeBackGround[idx+(x<<1)+1];
                  spr|=((attr&1)<<8);
                  dirtval=spr|(attr<<16);
                  if(gsmokedirt[y2][x]!=dirtval)
                  {
                     col=(attr&0x3c)>>2;
                     disp1943tile(pGSmokePlane,prey,(x<<5),spr,col,!(attr&0x40),(attr&0x80),1,-1);
                     gsmokedirt[y2][x]=dirtval;
                  }
               }
               idx-=0x10;
            }
         }
         else
         {
            for(y=0;y<9;y++)
            {
               y2=(y+top)%9;
               prey=(y2)<<5;
               idx&=0x7fff;
               for(x=0;x<8;x++)
               {
                  spr=pGSmokeBackGround[idx+(x<<1)];
                  attr=pGSmokeBackGround[idx+(x<<1)+1];
                  spr|=((attr&1)<<8);
                  dirtval=spr|(attr<<16);
                  if(gsmokedirt[y2][x]!=dirtval)
                  {
                     col=(attr&0x3c)>>2;
                     disp1943tile(pGSmokePlane,prey,((7-x)<<5),spr,col,(attr&0x40),!(attr&0x80),1,-1);
                     gsmokedirt[y2][x]=dirtval;
                  }
               }
               idx-=0x10;
            }
         }
      }

      bitx2=pCode[0xd802]&0x1f;


   //draw backgrounds
      if(b2)
         copygsmokebacks(bity2,bitx2,b2,obj);
      else
         fastclear();

   //draw foreground characters
      if (chon)
      {
         transcol=79;
         pWork2=&pCode[0xd020];
         pCol=&pCode[0xd420];
         if(FlipScreen)
         {
            for(y=2;y<31;y++)
            {
               prey=(y<<3)-8;
               for(x=0;x<32;x++,pWork2++,pCol++)
               {
                  spr=*pWork2|((*pCol&0xc0)<<2);
                  if(spr!=36)
                     charblitlktrans((x<<3),prey,spr,(*pCol)&0x1f,0,2);
               }
            }
         }
         else
         {
            for(y=2;y<31;y++)
            {
               prey=256-(y<<3);
               for(x=0;x<32;x++,pWork2++,pCol++)
               {
                  spr=*pWork2|((*pCol&0xc0)<<2);
                  if(spr!=36)
                     charblitlktrans(248-(x<<3),prey,spr,(*pCol)&0x1f,0,2);

               }
            }
         }
         transcol=0;
      }
   }
   else
   {

      idx=(((scrolly>>5)+8)<<4);
      top=(scrolly>>5)%9;

      idx=(((scrolly2>>5)+8)<<4)+((pCode[0xd802]>>5)<<1);

      if (pCode[0xd802]&0x80)
         idx-=0x10;


      top=(scrolly2>>5)%9;
      bity2=((top<<5)-(scrolly2&0x1f));
   //scrolling foreground
      if(bcheck)
      {
         if(FlipScreen)
         {
            for(y=0;y<9;y++)
            {
               y2=(y+top)%9;
               prey=(8-y2)<<5;
               idx&=0x7fff;
               for(x=0;x<8;x++)
               {
                  spr=pGSmokeBackGround[idx+(x<<1)];
                  attr=pGSmokeBackGround[idx+(x<<1)+1];
                  spr|=((attr&1)<<8);
                  dirtval=spr|(attr<<16);
                  if(gsmokedirt[y2][x]!=dirtval)
                  {
                     col=(attr&0x3c)>>2;
                     disp1943tile(pGSmokePlane,((7-x)<<5),prey,spr,col,(attr&0x80),!(attr&0x40),1,-1);
                     gsmokedirt[y2][x]=dirtval;
                  }
               }
               idx-=0x10;
            }
         }
         else
         {
            for(y=0;y<9;y++)
            {
               y2=(y+top)%9;

               prey=(y2)<<5;
               idx&=0x7fff;
               for(x=0;x<8;x++)
               {
                  spr=pGSmokeBackGround[idx+(x<<1)];
                  attr=pGSmokeBackGround[idx+(x<<1)+1];
                  spr|=((attr&1)<<8);
                  dirtval=spr|(attr<<16);
                  if(gsmokedirt[y2][x]!=dirtval)
                  {
                     col=(attr&0x3c)>>2;
                     disp1943tile(pGSmokePlane,(x<<5),prey,spr,col,!(attr&0x80),attr&0x40,1,-1);
                     gsmokedirt[y2][x]=dirtval;
                  }
               }
               idx-=0x10;
            }
         }
      }

      bitx2=pCode[0xd802]&0x1f;
   //draw backgrounds
      if(b2)
         copygsmokebacks(bity2,bitx2,b2,obj);
      else
         fastclear();
   //draw foreground characters

      if (chon)
      {
         transcol=79;
         pWork2=&pCode[0xd020];
         pCol=&pCode[0xd420];
         if(FlipScreen)
         {
            for(y=2;y<31;y++)
            {
               prey=264-(y<<3);
               for(x=0;x<32;x++,pWork2++,pCol++)
               {
                  spr=*pWork2|((*pCol&0xc0)<<2);

                  if(spr!=36)
                     charblitlktrans(prey,(x<<3),spr,(*pCol)&0x1f,0,2);
               }
            }
         }
         else
         {
            for(y=2;y<31;y++)
            {
               prey=(y<<3);
               for(x=0;x<32;x++,pWork2++,pCol++)
               {
                  spr=*pWork2|((*pCol&0xc0)<<2);
                  if(spr!=36)
                     charblitlktrans(prey,248-(x<<3),spr,(*pCol)&0x1f,0,2);
               }
            }
         }
         transcol=0;
      }
   }
}


UINT8 gsmokeprot(UINT32 offset,struct MemoryReadByte * mrb)
{
    static UINT8 gsdata[]={0xff,0x00,0x00};
    return gsdata[offset-mrb->lowAddr];
}




void gsmokebank(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{

   int newbank,flipper;
   int off=0xe800;
   int off2=0xe97c;

   chon=value&0x80;
   newbank=(value&0x1c)>>2;

   flipper=value>>6;

   if(gsmokeflip!=flipper)
   {
      flipscreenw(offset,flipper,mwb);
      gsmokeflip=flipper;
      cleargsmokeplanes();
   }

   if(CurGSmokeBank!=newbank)
   {
//move bytes which mz80 writes directy to the code base
      if(CurGSmokeBank!=-1)
      {
         fastcopy(&pGSmokeCodeBase[newbank][0xe800],&pGSmokeCodeBase[CurGSmokeBank][0xe800],0x10);
         *((DWORD *)&pGSmokeCodeBase[newbank][off2])=*((DWORD *)&pGSmokeCodeBase[CurGSmokeBank][off2]);
      }

      z80Base=pGSmokeCodeBase[newbank];
      CurGSmokeBank=newbank;
   }
}




void copygsmokebacks(int bity2,int bitx2,int b2,int obj)
{
   pBYTE pWork1;
   pBYTE pWork2;
   int x,y,idx,spr,color,prey,flipy;
   int frst,rem;
   int bank,bank3;

   bank3=pCode[0xd806]&0x07;

   if(!background)
   {
      b2=0;
      fastclear();
   }

   if(realorient)
   {

      if(b2)
      {
         int savebit;
         int xx,x2;
         if(FlipScreen)
         {
            bity2=288-bity2;
            xx=bitx2;
            x2=16;
         }
         else
         {
            bity2+=32;
            xx=16-bitx2;
            x2=0;
         }

         if(bity2>=288)
            bity2-=288;
         pWork2=pScreen+0x6020;
         savebit=bity2;

         if(bity2<33)
         {
            pWork1=pGSmokePlane+bity2+((xx+x2)<<9);

            for(y=0;y<224;y++)
            {
               fastcopy(pWork2,pWork1,64);
               pWork2+=512;
               pWork1+=512;
            }
         }
         else
         {
            frst=288-bity2;
            rem=256-frst;

            pWork1=pGSmokePlane+bity2+((xx+x2)<<9);
            for(y=0;y<224;y++)
            {
               memcpy(pWork2,pWork1,frst);
               memcpy(pWork2+frst,pWork1-bity2,rem);
               pWork2+=512;
               pWork1+=512;
            }
         }
      }


      if(obj)
      {
         if(FlipScreen)
         {
            for(idx=0xffe0;idx>=0xf000;idx-=32)
            {
               bank=(pCode[idx+1]&0xc0)>>6;
               if(bank==3)
                  bank+=bank3;
               spr=pCode[idx]+(bank<<8);

               if(spr)
               {
                  x=pCode[idx+3]-((pCode[idx+1]&0x20)<<3);
                  y=pCode[idx+2];
                  if(x>-16&&y>0)
                  {
                     flipy=!(pCode[idx+1]&0x10);
                     color=pCode[idx+1]&0x0f;
                     sprblitlk(x,y,spr,color,1,flipy,3,4,0);
                  }
               }
            }
         }
         else
         {
            for(idx=0xffe0;idx>=0xf000;idx-=32)
            {
               bank=(pCode[idx+1]&0xc0)>>6;
               if(bank==3)
                  bank+=bank3;
               spr=pCode[idx]+(bank<<8);

               if(spr)
               {
                  x=pCode[idx+3]-((pCode[idx+1]&0x20)<<3);
                  y=pCode[idx+2];
                  if(x>-16&&y>0)
                  {
                     flipy=(pCode[idx+1]&0x10);
                     color=pCode[idx+1]&0x0f;
                     sprblitlk(239-x,239-y,spr,color,0,flipy,3,4,0);
                  }
               }
            }
         }
      }
   }
   else
   {


      if(b2)
      {
         int xx;

         if(FlipScreen)
         {
            bity2=288-bity2;
            bitx2=16-bitx2;
            xx=0;
         }
         else
         {
            bity2+=32;
            xx=16;
         }



         if(bity2>=288)
            bity2-=288;




         pWork1=pGSmokePlane+bitx2+xx+(bity2<<9);

         pWork2=pScreen+0x4038;


         for(y=0;y<256;y++)
         {
            if(bity2==288)
            {
               bity2=0;
               pWork1=pGSmokePlane+xx+bitx2;
            }


            bity2++;
            fastcopy(pWork2,pWork1,58);
            pWork1+=512;
            pWork2+=512;
         }
      }

      if(obj)
      {
         if(FlipScreen)
         {
            for(idx=0xffe0;idx>=0xf000;idx-=32)
            {
               bank=(pCode[idx+1]&0xc0)>>6;
               if(bank==3)
                  bank+=bank3;
               spr=pCode[idx]+(bank<<8);

               if(spr)
               {
                  x=pCode[idx+3]-((pCode[idx+1]&0x20)<<3);
                  y=pCode[idx+2];
                  flipy=!(pCode[idx+1]&0x10);
                  if(x>-16&&y>0)
                  {
                     color=pCode[idx+1]&0x0f;
                     sprblitlk(248-y,x,spr,color,flipy,1,3,4,0);
                  }
               }
            }
         }
         else
         {
            for(idx=0xffe0;idx>=0xf000;idx-=32)
            {
               bank=(pCode[idx+1]&0xc0)>>6;
               if(bank==3)
                  bank+=bank3;
               spr=pCode[idx]+(bank<<8);

               if(spr)
               {
                  x=pCode[idx+3]-((pCode[idx+1]&0x20)<<3);
                  y=pCode[idx+2];
                  if(x>-16&&y>0)
                  {
                     flipy=(pCode[idx+1]&0x10);
                     color=pCode[idx+1]&0x0f;
                     sprblitlk(y+8,239-x,spr,color,flipy,0,3,4,0);
                  }
               }
            }
         }
      }

   }
}
