#include "main.h"
#include "gyrodvid.h"
#include "globals.h"
#include "twk.h"

static pBYTE pShared;

static int intson=TRUE;

void initgyro(void)
{
   keycodebase=1;
   pShared=calloc(0x10000,1);
}



void cleargyro(void)
{
   myfree(pShared);
}


void gyroint(void)
{
   if(intson)
      mz80nmi();
}


void gyroint2(void)
{
   mz80int(0xff);
}


void gyrointenable(UINT16 offset, UINT8 value, struct z80PortWrite *zpw)
{
   intson=value&1;
}

void gyropre(void)
{
   if(CurrentCPU==1)
      memcpy(&pCode[0x4000],pShared,0x800);
   else
      memcpy(&pCode[0xf000],pShared,0x800);

}

void gyropost(void)
{
   if(CurrentCPU==1)
      memcpy(pShared,&pCode[0x4000],0x800);
   else
      memcpy(pShared,&pCode[0xf000],0x800);


}


void gyrosharew(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   pShared[offset-mwb->lowAddr]=value;
//   loginfo("sharedw to 0x%x (0x%x)",offset-mwb->lowAddr,value);
}

UINT8 gyrosharer(UINT32 offset, struct MemoryReadByte *mrb)
{
//   loginfo("sharedr from 0x%x (0x%x)",offset-mrb->lowAddr,pShared[offset-mrb->lowAddr]);
   return pShared[offset-mrb->lowAddr];
}


UINT8 gyrosram(UINT32 offset, struct MemoryReadByte *mrb)
{
   return pCode[offset]|0xf0;
}


void gyroupdatescreen(void)
{
   int idx;

//{0x9000,0x97ff,MWA_RAM,&kyugo_videoram, &kyugo_videoram_size },
   for(idx = 0x7ff;idx>=0;idx-- )
	{
		int sx,sy,code;

      sx = idx % 64;
      sy = idx / 64;
/*
		if (flipscreen)
		{
			sx = 35 - sx;
			sy = 31 - sy;
		}
*/
      code=pCode[0x9000+idx];// kyugo_videoram[offs];

      dispchar(sy*8,sx*8,code,0);
/*
		drawgfx( bitmap, Machine->gfx[0],
				code,
				2*color_codes[code/8] + frontcolor,
				flipscreen, flipscreen,
				8*sx, 8*sy,
				&Machine->drv->visible_area,TRANSPARENCY_PEN,0);
*/
	}

}

void gyroflipscreen(UINT16 offset, UINT8 value, struct z80PortWrite *zpw)
{
}

void gyrosubcontrol(UINT16 offset, UINT8 value, struct z80PortWrite *zpw)
{
   loginfo("Sub control");
   if(value&1)
   {
      loginfo("start cpu 2");
      mz80GetContext(&context[CurrentCPU]);
      if(!CPURunning[1])
      {
         mz80SetContext(&context[1]);
         mz80reset();
         mz80GetContext(&context[1]);
      }
      mz80SetContext(&context[CurrentCPU]);
      CPURunning[1]=1;
   }
   else
   {
      loginfo("stop cpu 2");
      CPURunning[1]=0;
   }

}

void setgyropal(pBYTE pIn)
{
}

