#include "main.h"
#include "globals.h"
#include "joy.h"
#include "control.h"

int readjoystick(int NoJoys,int *buttons,int *x1,int *y1,int *x2,int *y2)
{
   int inval;
   int clicker=0;
   int mask;


   mask=3;
   *x1=0;
   *x2=0;
   *y1=0;
   *y2=0;
//only poll second joy if it exists
   if(NoJoys==2||joytype==JOY_6BUTTON||joytype==JOY_8BUTTON)
      mask=15;


   asm volatile ("cli");

   outportb(0x201,0);

   while(TRUE)
   {
      inval=inportb(0x201);
      if(inval&1)
         *x1+=1;
      if(inval&2)
         *y1+=1;
      if(inval&4)
         *x2+=1;
      if(inval&8)
         *y2+=1;
//break if delay too big
      clicker++;
      if(clicker==0xffff)
         break;
//break if we got everything
      if(!(inval&mask))
         break;
   }
   asm volatile ("sti");
//get buttons
   *buttons=inportb(0x201);

   return clicker;

}

int checkjoy(void)
{
   int dummy;
   switch(joytype)
   {
      case JOY_2BUTTON:
         loginfo("2 Button PC Joystick/pad selected");
         break;
      case JOY_4BUTTON:
         loginfo("4 Button PC Joystick/pad selected");
         break;
      case JOY_6BUTTON:
         loginfo("6 Button PC Joystick/pad selected");
         break;
      case JOY_8BUTTON:
         loginfo("8 Button PC Joystick/pad selected");
         break;
   }

//check for 1 joystick
   if(readjoystick(1,&dummy,&dummy,&dummy,&dummy,&dummy)==0xffff)
   {
      loginfo("NO PC Joystick/pad found");
      return 0;
   }
//if it's a 2button job,check for another one
   if(joytype==JOY_2BUTTON)
   {
      if(readjoystick(2,&dummy,&dummy,&dummy,&dummy,&dummy)==0xffff)
      {
         loginfo("1 PC Joystick/pad found");
         return 1;
      }
      else
      {
         loginfo("2 PC Joystick/pads found");
         return 2;
      }
   }
   loginfo("1 PC Joystick/pad found");
   return 1;
}

