#include "main.h"
#include "jrpacvid.h"
#include "globals.h"
#include "pacvid.h"
#include "galvid.h"
#include "twk.h"

static int charbank=0;
static int spritebank=0;
static int jrpriority=0;
static pBYTE pJrScreen;
int jrdirty[32*64];
int jrdirty2[32*4];

void jrpaccharbank(UINT32 offset,UINT8 value,struct MemoryWriteByte *mwb)
{
   charbank=(value&1)<<8;
}

void jrppacsrpitebank(UINT32 offset,UINT8 value,struct MemoryWriteByte *mwb)
{
   WRITE_MEM
   spritebank=value&1;
}


void jrpacprior(UINT32 offset,UINT8 value,struct MemoryWriteByte *mwb)
{
   jrpriority=value&1;
}
void initjrpac(void)
{
	/* The encryption PALs garble bits 0, 2 and 7 of the ROMs. The encryption */
	/* scheme is complex (basically it's a state machine) and can only be */
	/* faithfully emulated at run time. To avoid the performance hit that would */
	/* cause, here we have a table of the values which must be XORed with */
	/* each memory region to obtain the decrypted bytes. */
	/* Decryption table provided by David Caldwell (david@indigita.com) */
	/* For an accurate reproduction of the encryption, see jrcrypt.c */
	struct {
	    int count;
	    int value;
	} table[] =
	{
		{ 0x00C1, 0x00 },{ 0x0002, 0x80 },{ 0x0004, 0x00 },{ 0x0006, 0x80 },
		{ 0x0003, 0x00 },{ 0x0002, 0x80 },{ 0x0009, 0x00 },{ 0x0004, 0x80 },
		{ 0x9968, 0x00 },{ 0x0001, 0x80 },{ 0x0002, 0x00 },{ 0x0001, 0x80 },
		{ 0x0009, 0x00 },{ 0x0002, 0x80 },{ 0x0009, 0x00 },{ 0x0001, 0x80 },
		{ 0x00AF, 0x00 },{ 0x000E, 0x04 },{ 0x0002, 0x00 },{ 0x0004, 0x04 },
		{ 0x001E, 0x00 },{ 0x0001, 0x80 },{ 0x0002, 0x00 },{ 0x0001, 0x80 },
		{ 0x0002, 0x00 },{ 0x0002, 0x80 },{ 0x0009, 0x00 },{ 0x0002, 0x80 },
		{ 0x0009, 0x00 },{ 0x0002, 0x80 },{ 0x0083, 0x00 },{ 0x0001, 0x04 },
		{ 0x0001, 0x01 },{ 0x0001, 0x00 },{ 0x0002, 0x05 },{ 0x0001, 0x00 },
		{ 0x0003, 0x04 },{ 0x0003, 0x01 },{ 0x0002, 0x00 },{ 0x0001, 0x04 },
		{ 0x0003, 0x01 },{ 0x0003, 0x00 },{ 0x0003, 0x04 },{ 0x0001, 0x01 },
		{ 0x002E, 0x00 },{ 0x0078, 0x01 },{ 0x0001, 0x04 },{ 0x0001, 0x05 },
		{ 0x0001, 0x00 },{ 0x0001, 0x01 },{ 0x0001, 0x04 },{ 0x0002, 0x00 },
		{ 0x0001, 0x01 },{ 0x0001, 0x04 },{ 0x0002, 0x00 },{ 0x0001, 0x01 },
		{ 0x0001, 0x04 },{ 0x0002, 0x00 },{ 0x0001, 0x01 },{ 0x0001, 0x04 },
		{ 0x0001, 0x05 },{ 0x0001, 0x00 },{ 0x0001, 0x01 },{ 0x0001, 0x04 },
		{ 0x0002, 0x00 },{ 0x0001, 0x01 },{ 0x0001, 0x04 },{ 0x0002, 0x00 },
		{ 0x0001, 0x01 },{ 0x0001, 0x04 },{ 0x0001, 0x05 },{ 0x0001, 0x00 },
		{ 0x01B0, 0x01 },{ 0x0001, 0x00 },{ 0x0002, 0x01 },{ 0x00AD, 0x00 },
		{ 0x0031, 0x01 },{ 0x005C, 0x00 },{ 0x0005, 0x01 },{ 0x604E, 0x00 },
	    { 0,0 }
	};
	int i,j,A;


	A = 0;
	i = 0;
	while (table[i].count)
	{
		for (j = 0;j < table[i].count;j++)
		{
         pCode[A] ^= table[i].value;
			A++;
		}
		i++;
	}
   checkspeed();
   pJrScreen=myalloc(512*512);
   if(!pJrScreen)
      loginfo("Failed to allocate space for background");
   markjrdirty();
}


void markjrdirty(void)
{
   memset(jrdirty,-1,sizeof(int)*(32*64));
   memset(jrdirty2,-1,sizeof(int)*(32*4));
}

void jrpacsetpal(pBYTE pIn)
{
   int i;
   int idx;
   int bit0,bit1,bit2;
   for(idx=0;idx<32;idx++)
   {
      outportb(0x3c8,idx);

      bit0=(pIn[idx]&0x01)*0x21;
      bit1=((pIn[idx]>>1)&0x01)*0x47;
      bit2=((pIn[idx]>>2)&0x01)*0x97;
      outportb(0x3c9,(bit0+bit1+bit2)>>2);
      bit0=((pIn[idx]>>3)&0x01)*0x21;
      bit1=(pIn[idx+32]&0x01)*0x47;
      bit2=((pIn[idx+32]>>1)&0x01)*0x97;
      outportb(0x3c9,(bit0+bit1+bit2)>>2);
      bit1=((pIn[idx+32]>>2)&0x01)*0x47;
      bit2=((pIn[idx+32]>>3)&0x01)*0x97;
      outportb(0x3c9,(bit1+bit2)>>2);
   }


   for(i=0;i<256;i++)
      collookups[0][i]=pIn[i+64];
   for(i=0;i<256;i++)
	{
      if(pIn[i+64])
         collookups[0][i+256]=pIn[i+64]+0x10;
      else
         collookups[0][i+256]=0;
	}

}

void jrpacupdatescreen(void)
{
   int x,y,spr,col,prey,prey2;
   int predirt1,predirt2;
   int idx,work,prebank,presprite;
   int dirt;
   pBYTE pWork;
   pBYTE pWork2;

   prebank=((pCode[0x5071]&1)<<5)+((pCode[0x5070]&1)<<6);
   presprite=((spritebank&1)<<6);

   if(realorient)
   {
      if(FlipScreen)
      {
         pWork=&pCode[0x4000+((32-6)<<5)];
         for(y=0;y<32;y++)
         {
            prey=y<<6;
            for(x=0;x<32;x++,pWork++)
            {
               spr=*pWork|charbank;
               col=(pCode[0x4000+x]&0x1f)|prebank;
               dirt=spr|col<<16;
               if(jrdirty[x+prey]!=dirt)
               {
                  charblitlktmp(pJrScreen,248-(x<<3),511-((256-7)+(y<<3)),spr,col,0,2);
                  jrdirty[x+prey]=dirt;
               }
            }
         }

         pWork=&pCode[0x4000+32];
         for(y=1;y<(32-6);y++)
         {
            prey=y<<6;
            for(x=0;x<32;x++,pWork++)
            {
               spr=*pWork|charbank;
               col=(pCode[0x4000+x]&0x1f)|prebank;
               dirt=spr|col<<16;
               if(jrdirty[(x+32)+prey]!=dirt)
               {
                  charblitlktmp(pJrScreen,248-(x<<3),511-((511-7)-((511-48)-(y<<3))),spr,col,0,2);
                  jrdirty[(x+32)+prey]=dirt;
               }
            }
         }

         flipjrscreen();
         pWork=&pCode[0x4000+(58*32)];
         pWork2=&pCode[0x4000+(56*32)];
         for(y=0;y<2;y++)
         {
            prey=(35-y)<<3;
            prey2=(1-y)<<3;
            predirt1=(y<<5);
            predirt2=((y+2)<<5);
            for(x=0;x<32;x++,pWork++,pWork2++)
            {
               spr=*pWork;
               col=(pWork[128]&0x1f)|prebank;
               dirt=spr|col<<16;
               if(jrdirty2[x+predirt1]!=dirt)
               {
                  charblitlk(prey,(255-(x<<3))-7,spr,col,0,2);
                  jrdirty2[x+predirt1]=dirt;
               }

               spr=*pWork2|charbank;
               col=(pWork2[128]&0x1f)|prebank;
               dirt=spr|col<<16;
               if(jrdirty2[x+predirt2]!=dirt)
               {
                  charblitlk(prey2,(255-(x<<3))-7,spr,col,0,2);
                  jrdirty2[x+predirt2]=dirt;
               }
            }
         }

      }
      else
      {
         pWork=&pCode[0x4000+((32-6)<<5)];
         for(y=0;y<32;y++)
         {
            prey=y<<6;
            for(x=0;x<32;x++,pWork++)
            {
               spr=*pWork|charbank;
               col=(pCode[0x4000+x]&0x1f)|prebank;
               dirt=spr|col<<16;
               if(jrdirty[x+prey]!=dirt)
               {
                  charblitlktmp(pJrScreen,(x<<3),(256-7)+(y<<3),spr,col,0,2);
                  jrdirty[x+prey]=dirt;
               }
            }
         }

         pWork=&pCode[0x4000+32];
         for(y=1;y<(32-6);y++)
         {
            prey=y<<6;
            for(x=0;x<32;x++,pWork++)
            {
               spr=*pWork|charbank;
               col=(pCode[0x4000+x]&0x1f)|prebank;
               dirt=spr|col<<16;
               if(jrdirty[(x+32)+prey]!=dirt)
               {
                  charblitlktmp(pJrScreen,(x<<3),(511-7)-((511-48)-(y<<3)),spr,col,0,2);
                  jrdirty[(x+32)+prey]=dirt;
               }
            }
         }

         flipjrscreen();
         pWork=&pCode[0x4000+(58*32)];
         pWork2=&pCode[0x4000+(56*32)];
         for(y=0;y<2;y++)
         {
            prey=y<<3;
            prey2=(y+34)<<3;
            predirt1=(y<<5);
            predirt2=((y+2)<<5);
            for(x=0;x<32;x++,pWork++,pWork2++)
            {
               spr=*pWork;
               col=(pWork[128]&0x1f)|prebank;
               dirt=spr|col<<16;
               if(jrdirty2[x+predirt1]!=dirt)
               {
                  charblitlk(prey,(x<<3),spr,col,0,2);
                  jrdirty2[x+predirt1]=dirt;
               }

               spr=*pWork2|charbank;
               col=(pWork2[128]&0x1f)|prebank;
               dirt=spr|col<<16;
               if(jrdirty2[x+predirt2]!=dirt)
               {
                  charblitlk(prey2,(x<<3),spr,col,0,2);
                  jrdirty2[x+predirt2]=dirt;
               }
            }
         }
      }
      if(ror)
      {
         for(idx=0x4ffe;idx>=0x4ff0;idx-=2)
         {
            work=idx+0x70;
            if(pCode[work+1]&&pCode[work])
            {
               spr=(pCode[idx]>>2)|presprite;
               x=pCode[work+1];
               y=255-pCode[work];
               col=(pCode[idx+1]&0x1f)|prebank;
               sprblitlk(x,y,spr,col,!(pCode[idx]&1),!(pCode[idx]&2),0,2,jrpriority);
            }
         }
      }
      else
      {
         for(idx=0x4ffe;idx>=0x4ff0;idx-=2)
         {
            work=idx+0x70;
            if(pCode[work+1]&&pCode[work])
            {
               spr=(pCode[idx]>>2)|presprite;
               x=(255-pCode[work+1])+16;
               y=pCode[work]-16;
               col=(pCode[idx+1]&0x1f)|prebank;
               sprblitlk(x,y,spr,col,(pCode[idx]&1),(pCode[idx]&2),0,2,jrpriority);
            }
         }
      }
   }
   else
   {
      if(FlipScreen)
      {
         pWork=&pCode[0x4000+((32-6)<<5)];
         for(y=0;y<32;y++)
         {
            prey=y<<6;
            for(x=0;x<32;x++,pWork++)
            {
               spr=*pWork|charbank;
               col=(pCode[0x4000+x]&0x1f)|prebank;
               dirt=spr|col<<16;
               if(jrdirty[x+prey]!=dirt)
               {
                  charblitlktmp(pJrScreen,511-(255-(y<<3)),248-(x<<3),spr,col,0,2);
                  jrdirty[x+prey]=dirt;
               }
            }
         }

         pWork=&pCode[0x4000];
         for(y=0;y<(32-6);y++)
         {
            prey=y<<6;
            for(x=0;x<32;x++,pWork++)
            {
               spr=*pWork|charbank;
               col=(pCode[0x4000+x]&0x1f)|prebank;
               dirt=spr|col<<16;
               if(jrdirty[(x+32)+prey]!=dirt)
               {
                  charblitlktmp(pJrScreen,511-((511-48)-(y<<3)),248-(x<<3),spr,col,0,2);
                  jrdirty[(x+32)+prey]=dirt;
               }
            }
         }

         flipjrscreen();
         pWork=&pCode[0x4000+(58*32)];
         pWork2=&pCode[0x4000+(56*32)];
         for(y=0;y<2;y++)
         {
            prey=(35-y)<<3;
            prey2=(1-y)<<3;
            predirt1=(y<<5);
            predirt2=((y+2)<<5);
            for(x=0;x<32;x++,pWork++,pWork2++)
            {
               spr=*pWork;
               col=(pWork[128]&0x1f)|prebank;
               dirt=spr|col<<16;
               if(jrdirty2[x+predirt1]!=dirt)
               {
                  charblitlk((x<<3)+7,prey,spr,col,0,2);
                  jrdirty2[x+predirt1]=dirt;
               }

               spr=*pWork2|charbank;
               col=(pWork2[128]&0x1f)|prebank;
               dirt=spr|col<<16;
               if(jrdirty2[x+predirt2]!=dirt)
               {
                  charblitlk((x<<3)+7,prey2,spr,col,0,2);
                  jrdirty2[x+predirt2]=dirt;
               }
            }
         }
      }
      else
      {
         pWork=&pCode[0x4000+((32-6)<<5)];
         for(y=0;y<32;y++)
         {
            prey=y<<6;
            for(x=0;x<32;x++,pWork++)
            {
               spr=*pWork|charbank;
               col=(pCode[0x4000+x]&0x1f)|prebank;
               dirt=spr|col<<16;
               if(jrdirty[x+prey]!=dirt)
               {
                  charblitlktmp(pJrScreen,255-(y<<3),(x<<3),spr,col,0,2);
                  jrdirty[x+prey]=dirt;
               }
            }
         }

         pWork=&pCode[0x4000];
         for(y=0;y<(32-6);y++)
         {
            prey=y<<6;
            for(x=0;x<32;x++,pWork++)
            {
               spr=*pWork|charbank;
               col=(pCode[0x4000+x]&0x1f)|prebank;
               dirt=spr|col<<16;
               if(jrdirty[(x+32)+prey]!=dirt)
               {
                  charblitlktmp(pJrScreen,(511-48)-(y<<3),(x<<3),spr,col,0,2);
                  jrdirty[(x+32)+prey]=dirt;
               }
            }
         }

         flipjrscreen();
         pWork=&pCode[0x4000+(58*32)];
         pWork2=&pCode[0x4000+(56*32)];
         for(y=0;y<2;y++)
         {
            prey=y<<3;
            prey2=(y+34)<<3;
            predirt1=(y<<5);
            predirt2=((y+2)<<5);
            for(x=0;x<32;x++,pWork++,pWork2++)
            {
               spr=*pWork;
               col=(pWork[128]&0x1f)|prebank;
               dirt=spr|col<<16;
               if(jrdirty2[x+predirt1]!=dirt)
               {
                  charblitlk(255-(x<<3),prey,spr,col,0,2);
                  jrdirty2[x+predirt1]=dirt;
               }

               spr=*pWork2|charbank;
               col=(pWork2[128]&0x1f)|prebank;
               dirt=spr|col<<16;
               if(jrdirty2[x+predirt2]!=dirt)
               {
                  charblitlk(255-(x<<3),prey2,spr,col,0,2);
                  jrdirty2[x+predirt2]=dirt;
               }
            }
         }
      }

      if(flipxy)
      {
         for(idx=0x4ffe;idx>=0x4ff0;idx-=2)
         {
            work=idx+0x70;
            if(pCode[work+1]&&pCode[work])
            {
               spr=(pCode[idx]>>2)|presprite;
               x=pCode[work+1];
               y=pCode[work]-8;
               col=(pCode[idx+1]&0x1f)|prebank;
               sprblitlk(y,x,spr,col,!(pCode[idx]&2),!(pCode[idx]&1),0,2,jrpriority);
            }
         }
      }
      else
      {
         for(idx=0x4ffe;idx>=0x4ff0;idx-=2)
         {
            work=idx+0x70;
            if(pCode[work+1]&&pCode[work])
            {
               spr=(pCode[idx]>>2)|presprite;
               x=(255-pCode[work+1])+16;
               y=(255+8)-pCode[work];
               col=(pCode[idx+1]&0x1f)|prebank;
               sprblitlk(y,x,spr,col,(pCode[idx]&2),(pCode[idx]&1),0,2,jrpriority);
            }
         }
      }

   }

}

void clearjrpac(void)
{
   myfree(pJrScreen);
}

void flipjrscreen(void)
{
   pBYTE pWork1;
   pBYTE pWork2;
   int y;
   BYTE scroll;

   if(realorient)
   {
      if(FlipScreen)
         scroll=(128+64+30)-pCode[0x5080];
      else
         scroll=pCode[0x5080]+41;

      pWork1=pJrScreen+(scroll<<9);
      pWork2=pScreen+32+16+(32<<9);

   }
   else
   {
      if(FlipScreen)
         scroll=pCode[0x5080]+41;
      else
         scroll=((240-32)-pCode[0x5080]);
      pWork1=pJrScreen+scroll;
      pWork2=pScreen+32+((32+16)<<9);
   }

   for(y=0;y<256;y++)
   {
      fastcopy(pWork2,pWork1,64);
      pWork1+=512;
      pWork2+=512;
   }
}
