#ifndef _LADYBUG_BRD_H_
#define _LADYBUG_BRD_H_


ROMSTRUCT ladybugcode[]=
{
   {"lb1.cpu",0x0000,0x1000,0x0000},
   {"lb2.cpu",0x1000,0x1000,0x0000},
   {"lb3.cpu",0x2000,0x1000,0x0000},
   {"lb4.cpu",0x3000,0x1000,0x0000},
   {"lb5.cpu",0x4000,0x1000,0x0000},
   {"lb6.cpu",0x5000,0x1000,0x0000},
   {"",0,0,0}
};


ROMSTRUCT ladybuggfx[]=
{
   {"lb9.vid",0x0000,0x1000,0x0000},
   {"lb10.vid",0x1000,0x1000,0x0000},
   {"lb8.cpu",0x2000,0x1000,0x0000},
   {"lb7.cpu",0x3000,0x1000,0x0000},
   {"",0,0,0}
};


ROMSTRUCT ladybugcol[]=
{
   {"10-2.vid",0x0000,0x0020,0x0000},
   {"10-1.vid",0x0020,0x0020,0x0000},
   {"10-3.vid",0x0040,0x0020,0x0000},
   {"",0,0,0}
};




INPUTS ladybuginputs[]=
{
   {K_PL1_LEFT,0x9000,0x01,0,0},
   {K_PL1_DOWN,0x9000,0x02,0,0},
   {K_PL1_RIGHT,0x9000,0x04,0,0},
   {K_PL1_UP,0x9000,0x08,0,0},
   {K_NO_MATCH,0x9000,0x10,0,0},
   {K_PL1_START,0x9000,0x20,0,0},
   {K_PL2_START,0x9000,0x40,0,0},
   {K_NO_MATCH,0x9000,0x80,0,0},

   {K_PL2_LEFT,0x9001,0x01,0,0},
   {K_PL2_DOWN,0x9001,0x02,0,0},
   {K_PL2_RIGHT,0x9001,0x04,0,0},
   {K_PL2_UP,0x9001,0x08,0,0},
   {K_NO_MATCH,0x9001,0x10,0,0},
   {K_NO_MATCH,0x9001,0x20,0,0},

   {K_NO_MATCH,0xe000,0x01,0,0},
   {K_NO_MATCH,0xe000,0x0e,0,0},
   {K_PL2_B1,0xe000,0x10,0,0},
   {K_NO_MATCH,0xe000,0xe0,0,0},


   {K_COIN1,0x10000,0x01,128,1},
   {K_COIN2,0x10000,0x02,128,1},


   {-1,-1,0,0,0}
};



//layout of chars
SPRLAYOUT ladyclayout={16,512,2,{512*8*8,0},{7,6,5,4,3,2,1,0},{7,6,5,4,3,2,1,0},8};
SPRLAYOUT ladyclayout2={16,512,2,{1,0},{0,2,4,6,8,10,12,14},
   { 7*2, 6*2, 5*2, 4*2, 3*2, 2*2, 1*2, 0 },16};

//layout of sprites
SPRLAYOUT ladyslayout={
   16,128,2,{1,0},
   {
   8*16+8,8*16+10,8*16+12,8*16+14,
   8*16+0,8*16+2,8*16+4,8*16+6,
   8,10,12,14,
   0,2,4,6
   },
   {23*2, 22*2, 21*2, 20*2, 19*2, 18*2, 17*2, 16*2,
         7*2, 6*2, 5*2, 4*2, 3*2, 2*2, 1*2, 0 },64};


GFXDETAILS ladybuggfxs[]=
{
   {0,0,8,8,&ladyclayout,0,TYPE_CHAR},
   {0x2000,0,16,16,&ladyslayout,1,TYPE_SPR},
   {0x2000,512,8,8,&ladyclayout2,-1,TYPE_CHAR},
   {-1,0,0,0,0,0,0}
};



#define LADYBUGDIPS \
   { \
   {1,0,0,0,0, \
      { \
         {DIP_DIFFICULTY,3,0, \
            { \
               {DIP_EASY,0,3},{DIP_NORMAL,0,2},{DIP_HARD,0,1},{DIP_HARDEST,0,0} \
            } \
         }, \
         {"Names",4,0, \
            {\
               {"3 Letters",0,0},{"10 Letters",0,4} \
            }\
         }, \
         {DIP_RACK,8,0, \
            { \
               {DIP_OFF,0,8},{DIP_ON,0,0} \
            } \
         }, \
         {DIP_FREEZE,0x10,0, \
            { \
               {DIP_OFF,0,0x10},{DIP_ON,0,0} \
            } \
         }, \
         {DIP_CABINET,0,0, \
            { \
               {DIP_UPRIGHT,0,0},{DIP_COCKTAIL,0,0x20} \
            } \
         }, \
         {DIP_FREE,0x40,0, \
            { \
               {DIP_OFF,0,0x40},{DIP_ON,0,0} \
            } \
         }, \
         {DIP_LIVES,0x80,0, \
            { \
               {"3",0,0x80},{"5",0,0x0} \
            } \
         } \
      } \
   }, \
   {2,0,0,0,0, \
      { \
         {"Right Coin",0x0f,0, \
            { \
               {DIP_4C_1C,0,0x05},{DIP_3C_1C,0,0x07},{DIP_2C_1C,0,0x0a}, \
               {DIP_3C_2C,0,0x06},{DIP_2C_2C,0,0x09},{DIP_1C_1C,0,0x0f}, \
               {DIP_2C_3C,0,0x08},{DIP_1C_2C,0,0x0e},{DIP_1C_3C,0,0x0d}, \
               {DIP_1C_4C,0,0x0c},{DIP_1C_5C,0,0x0b} \
            } \
         }, \
         {"Left Coin",0xf0,0, \
            { \
               {DIP_4C_1C,0,0x50},{DIP_3C_1C,0,0x70},{DIP_2C_1C,0,0xa0}, \
               {DIP_3C_2C,0,0x60},{DIP_2C_2C,0,0x90},{DIP_1C_1C,0,0xf0}, \
               {DIP_2C_3C,0,0x80},{DIP_1C_2C,0,0xe0},{DIP_1C_3C,0,0xd0}, \
               {DIP_1C_4C,0,0xc0},{DIP_1C_5C,0,0xb0} \
            } \
         } \
      } \
   } \
   }
#endif
