#ifndef _MRDO_BRD_H_
#define _MRDO_BRD_H_

ROMSTRUCT mrdocode[]=
{
   {"a4-01.bin",0x0000,0x2000,0x0000},
   {"c4-02.bin",0x2000,0x2000,0x0000},
   {"e4-03.bin",0x4000,0x2000,0x0000},
   {"f4-04.bin",0x6000,0x2000,0x0000},
   {"",0,0,0}
};



ROMSTRUCT mrdogfx[]=
{
   {"s8-09.bin",0x0000,0x1000,0x0000},
   {"u8-10.bin",0x1000,0x1000,0x0000},
   {"r8-08.bin",0x2000,0x1000,0x0000},
   {"n8-07.bin",0x3000,0x1000,0x0000},
   {"h5-05.bin",0x4000,0x1000,0x0000},
   {"k5-06.bin",0x5000,0x1000,0x0000},
   {"",0,0,0}
};


ROMSTRUCT mrdocol[]=
{
   {"u02--2.bin",0x0000,0x0020,0x0000},
   {"t02--3.bin",0x0020,0x0020,0x0000},
   {"f10--1.bin",0x0040,0x0020,0x0000},
   {"",0,0,0}
};

ROMSTRUCT yankeedocode[]=
{
   {"a4-01.bin",0x0000,0x2000,0x0000},
   {"yd_d2.c4",0x2000,0x2000,0x0000},
   {"e4-03.bin",0x4000,0x2000,0x0000},
   {"f4-04.bin",0x6000,0x2000,0x0000},
   {"",0,0,0}
};
ROMSTRUCT yankeedogfx[]=
{
   {"s8-09.bin",0x0000,0x1000,0x0000},
   {"u8-10.bin",0x1000,0x1000,0x0000},
   {"r8-08.bin",0x2000,0x1000,0x0000},
   {"n8-07.bin",0x3000,0x1000,0x0000},
   {"yd_d5.h5",0x4000,0x1000,0x0000},
   {"yd_d6.k5",0x5000,0x1000,0x0000},
   {"",0,0,0}
};

ROMSTRUCT yankeedocol[]=
{
   {"u02--2.bin",0x0000,0x0020,0x0000},
   {"t02--3.bin",0x0020,0x0020,0x0000},
   {"f10--1.bin",0x0040,0x0020,0x0000},
   {"",0,0,0}
};


INPUTS mrdoinputs[]=
{
   {K_PL1_LEFT,0xa000,0x01,0,0},
   {K_PL1_DOWN,0xa000,0x02,0,0},
   {K_PL1_RIGHT,0xa000,0x04,0,0},
   {K_PL1_UP,0xa000,0x08,0,0},
   {K_PL1_B1,0xa000,0x10,0,0},
   {K_PL1_START,0xa000,0x20,0,0},
   {K_PL2_START,0xa000,0x40,0,0},
   {K_NO_MATCH,0xa000,0x80,0,0},

   {K_PL2_LEFT,0xa001,0x01,0,0},
   {K_PL2_DOWN,0xa001,0x02,0,0},
   {K_PL2_RIGHT,0xa001,0x04,0,0},
   {K_PL2_UP,0xa001,0x08,0,0},
   {K_PL2_B1,0xa001,0x10,0,0},
   {K_NO_MATCH,0xa001,0x20,0,0},
   {K_COIN1,0xa001,0x40,0,0},
   {K_COIN2,0xa001,0x80,0,0},

   {-1,-1,0,0,0}
};

SPRLAYOUT mrdoslayout={16,128,2,{4,0},{27,26,25,24,19,18,17,16,11,10,9,8,3,2,1,0},{0,4,8,12,16,20,24,28,32,36,40,44,48,52,56,60},64};
SPRLAYOUT mrdoclayout={64,512,2,{512*8*8,0},{7,6,5,4,3,2,1},{7,6,5,4,3,2,1,0},8};

GFXDETAILS mrdogfxs[]=
{
   {0,0,8,8,&mrdoclayout,-1,TYPE_CHAR},
   {0x2000,512,8,8,&mrdoclayout,-1,TYPE_CHAR},
   {0x4000,0,16,16,&mrdoslayout,0,TYPE_SPR},
   {-1,0,0,0,0,0,0}
};


#define MRDODIPS \
   { \
   {1,0,0,0,0, \
      { \
         {DIP_DIFFICULTY,3,0, \
            { \
               {DIP_EASY,0,3},{DIP_NORMAL,0,2},{DIP_HARD,0,1},{DIP_HARDEST,0,0} \
            } \
         }, \
         {DIP_RACK,4,0, \
            { \
               {DIP_OFF,0,4},{DIP_ON,0,0} \
            } \
         }, \
         {"Special",8,0, \
            { \
               {DIP_EASY,0,8},{DIP_HARD,0,0} \
            } \
         }, \
         {"Extra",0x10,0, \
            { \
               {DIP_EASY,0,0x10},{DIP_HARD,0,0} \
            } \
         }, \
         {DIP_CABINET,0,0, \
            { \
               {DIP_UPRIGHT,0,0},{DIP_COCKTAIL,0,0x20} \
            } \
         }, \
         {DIP_LIVES,0xc0,0, \
            { \
               {"2",0,0},{"3",0,0xc0},{"4",0,0x80},{"5",0,0x40} \
            } \
         } \
      } \
   }, \
   {2,0,0,0,0, \
      { \
         {DIP_COINA,0x0f,0, \
            { \
               {DIP_1C_1C,0,0x0f},{DIP_1C_2C,0,0x0e},{DIP_1C_3C,0,0x0d},{DIP_1C_4C,0,0x0c}, \
               {DIP_1C_5C,0,0x0b},{DIP_2C_1C,0,0x0a},{DIP_2C_3C,0,0x09},{DIP_3C_1C,0,0x08}, \
               {DIP_3C_2C,0,0x07},{DIP_4C_1C,0,0x06},{DIP_FREE,0,0x00}, \
            } \
         }, \
         {DIP_COINB,0xf0,0, \
            { \
               {DIP_1C_1C,0,0xf0},{DIP_1C_2C,0,0xe0},{DIP_1C_3C,0,0xd0},{DIP_1C_4C,0,0xc0}, \
               {DIP_1C_5C,0,0xb0},{DIP_2C_1C,0,0xa0},{DIP_2C_3C,0,0x90},{DIP_3C_1C,0,0x80}, \
               {DIP_3C_2C,0,0x70},{DIP_4C_1C,0,0x60},{DIP_FREE,0,0x00}, \
            } \
         } \
      } \
   } \
   }
#endif
