#ifndef _PAC_MEM_H_
#define _PAC_MEM_H_

struct MemoryWriteByte PacWrite[] =
{
   {0x0000,0x3fff,romwrite,NULL},
   {0x4000,0x43ff,pacvideowrite,NULL},
   {0x4400,0x47ff,paccolwrite,NULL},
   {0x5000,0x5000,romwrite,NULL},
   {0x5003,0x5003,flipscreenw,NULL},
   {0x5040,0x505f,namcosndw,NULL},
   {0xc000,0xc3ff,pacvideowrite,NULL},
   {0xc400,0xc7ef,paccolwrite,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};


struct MemoryWriteByte MsPacWrite[] =
{
   {0x0000,0x3fff,romwrite,NULL},
   {0x4000,0x43ff,pacvideowrite,NULL},
   {0x4400,0x47ff,paccolwrite,NULL},
   {0x5000,0x5000,romwrite,NULL},
   {0x5003,0x5003,flipscreenw,NULL},
   {0x5040,0x505f,namcosndw,NULL},
   {0xc000,0xc3ff,pacvideowrite,NULL},
   {0xc400,0xc7ef,paccolwrite,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};


struct MemoryReadByte PacRead[] =
{
   {0x5000,0x503f,dip1,NULL},
   {0x5040,0x507f,dip2,NULL},
   {0x5080,0x50bf,dip3,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};


struct MemoryWriteByte DreamWrite[] =
{
   {0x0000,0x3fff,romwrite,NULL},
   {0x4000,0x43ff,pacvideowrite,NULL},
   {0x4400,0x47ff,paccolwrite,NULL},
   {0x5000,0x5000,pacintenablew,NULL},
   {0x5003,0x5003,ivflipscreenw,NULL},
   {0x5040,0x505f,namcosndw,NULL},
   {0xc000,0xc3ff,pacvideowrite,NULL},
   {0xc400,0xc7ef,paccolwrite,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryReadByte DreamRead[] =
{
   {0x5080,0x50bf,dip1,NULL},
   {0x50c0,0x50ff,dreamnon,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};


struct MemoryReadByte CrushRead[] =
{
   {0x5000,0x503f,dip1,NULL},
   {0x5080,0x50bf,dip2,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryReadByte VanVanRead[] =
{
   {0x5080,0x50bf,dip1,NULL},
   {0x50c0,0x50ff,dip2,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};


struct MemoryReadByte LizWizRead[] =
{
   {0x5080,0x50bf,dip1,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

//we're ROM bank switching - so we need to memory map the whole thing (read - SLOW)
struct MemoryWriteByte TheGlobWrite[] =
{
   {0x0000,0x3fff,romwrite,NULL},
   {0x4000,0x43ff,pacvideowrite,NULL},
   {0x4400,0x47ff,paccolwrite,NULL},
   {0x4800,0x4fff,ramwrite,NULL},
   {0x5000,0x5000,romwrite,NULL},
   {0x5003,0x5003,flipscreenw,NULL},
   {0x5040,0x505f,namcosndw,NULL},
   {0x5060,0x506f,ramwrite,NULL},
   {0xc000,0xc3ff,pacvideowrite,NULL},
   {0xc400,0xc7ef,paccolwrite,NULL},
   {0xc7f0,0xffff,ramwrite,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryReadByte TheGlobRead[] =
{
   {0x4000,0x503f,ramread,NULL},
   {0x5040,0x507f,dip1,NULL},
   {0x5080,0x50bf,dip2,NULL},
   {0x50c0,0x50ff,nopread,NULL},
   {0x5100,0xffff,ramread,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct z80PortWrite PacWritePorts[] =
{
   {0x00,0x00,pacintvw,NULL},
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};


struct z80PortWrite VanVanWritePorts[] =
{
   {0x01,0x01,SN76496_0_pw,NULL},
   {0x02,0x02,SN76496_1_pw,NULL},
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};

struct z80PortRead TheGlobReadPorts[] =
{
   {0x00,0xff,theglobdecrypt,NULL},
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};

#endif
