#include "main.h"
#include "globals.h"

extern char snappath[512];

int compresspcx(pPCXSTRUCT pcx)
{
	pBYTE	scratch;
	pBYTE	pfout;
	pBYTE	pfwork;
   int csize;
   int ptr;
   int pixrun;
   BYTE pixval;
   int runval;
   int memsize;
   int x,y;

   memsize=pBoard->boardScreen[realorient].xsize*pBoard->boardScreen[realorient].ysize;

   scratch=myalloc(memsize*2);

	csize=0;

	pixrun=0;
	pixval=0;
	runval=0;
	pfwork=pcx->image;
	pfout=scratch;

   x=y=00;
   for(ptr=0;ptr<memsize;ptr++)
	{
		pixval=*pfwork++;
		if((pixval&192))
		{
			if(pixrun)
			{
				if(pixrun==1)
				{
					*pfout++=runval;
				}
				else
				{
					*pfout++=192|pixrun;
					*pfout++=runval;
				}
			}
			*pfout++=193;
			*pfout++=pixval;
			pixrun=0;
		}
		else
		{
			if(pixrun==0)
			{
				runval=pixval;
				pixrun=1;
			}
			else
			{
				if(pixval==runval)
				{
					pixrun++;
					if(pixrun==63)
					{
						*pfout++=255;
						*pfout++=runval;
						pixrun=0;
					}
				}
				else
				{
					if(pixrun)
					{
						if(pixrun==1)
						{
							*pfout++=runval;

						}
						else
						{
							*pfout++=192|pixrun;
							*pfout++=runval;
						}
					}
					pixrun=1;
					runval=pixval;
				}
			}

		}
      x++;
      if(x>pcx->header.xmax)
      {
         x=0;
         pfwork+=(511-pcx->header.xmax);
      }
	}

	if(pixrun)
	{
		if(pixrun==1)
		{
			*pfout++=runval;

		}
		else
		{
			*pfout++=192|pixrun;
			*pfout++=runval;

		}
	}
	csize=(int)(pfout-scratch);

//allocate space for the thing
	pcx->cimage=myalloc(csize);
//and copy it across
	memcpy(pcx->cimage,scratch,csize);
	pcx->clength=csize;
	myfree(scratch);

	return TRUE;
}

int savepcx(char *filename,pPCXSTRUCT pcx)
{
   int   n;
   FILE *outfile;
	BYTE	work;

   outfile=fopen(filename,"wb");
   if(!outfile)
	{
      loginfo("Unable to create PCX file %s",filename);
		return FALSE;
	}
//write out the header
   fwrite(&pcx->header,sizeof(PCXHEADER),1,outfile);
   compresspcx(pcx);
//and the bitmap
   fwrite(pcx->cimage,pcx->clength,1,outfile);
	work=12;
   fwrite(&work,1,1,outfile);


//and the palette
   for(n=0;n<256;n++)
   {
      outportb(0x3c7,n);
      pcx->palette[n*3]=inportb(0x3c9)<<2;
      pcx->palette[(n*3)+1]=inportb(0x3c9)<<2;
      pcx->palette[(n*3)+2]=inportb(0x3c9)<<2;
   }

   fwrite(pcx->palette,1,768,outfile);

   fclose(outfile);


	return	TRUE;
}

void savesshot(void)
{
   static char szName[512];
	int	n=0;
	PCXSTRUCT pcx;
   sprintf(szName,"%s\\%s.pcx",snappath,pBoard->name);
//setup 256 colour PCX
   pcx.header.manufacturer=10;
   pcx.header.version=5;
   pcx.header.encoding=1;
   pcx.header.bits_per_pixel=8;
   pcx.header.xmin=0;
   pcx.header.ymin=0;
   pcx.header.xmax=pBoard->boardScreen[realorient].xsize-1;
   pcx.header.ymax=pBoard->boardScreen[realorient].ysize-1;
   pcx.header.hres=150;
   pcx.header.vres=150;
   pcx.header.reserved=0;
   pcx.header.color_planes=1;
   pcx.header.bytes_per_line=pBoard->boardScreen[realorient].xsize;
   pcx.header.palette_type=1;
   pcx.image=pBoard->pScreen;

	savepcx(szName,&pcx);
}



