#ifndef _PENGO_BRD_H_
#define _PENGO_BRD_H_

ROMSTRUCT pengocode[]=
{
   {"ic8",0x0000,0x1000,0x0000},
   {"ic7",0x1000,0x1000,0x0000},
   {"ic15",0x2000,0x1000,0x0000},
   {"ic14",0x3000,0x1000,0x0000},
   {"ic21",0x4000,0x1000,0x0000},
   {"ic20",0x5000,0x1000,0x0000},
   {"ic32",0x6000,0x1000,0x0000},
   {"ic31",0x7000,0x1000,0x0000},
   {"",0,0,0}
};

ROMSTRUCT pengo2ucode[]=
{
   {"pengo.u8",0x0000,0x1000,0x0000},
   {"pengo.u7",0x1000,0x1000,0x0000},
   {"pengo.u15",0x2000,0x1000,0x0000},
   {"pengo.u14",0x3000,0x1000,0x0000},
   {"pengo.u21",0x4000,0x1000,0x0000},
   {"pengo.u20",0x5000,0x1000,0x0000},
   {"pengo.u32",0x6000,0x1000,0x0000},
   {"pengo.u31",0x7000,0x1000,0x0000},
   {"",0,0,0}
};

ROMSTRUCT pengogfx[]=
{
   {"ic92",0x0000,0x2000,0x0000},
   {"ic105",0x2000,0x2000,0x0000},
   {"",0,0,0}
};

ROMSTRUCT pengocol[]=
{
   {"pr1633.078",0x0000,0x0020,0x0000},
   {"pr1634.088",0x0020,0x0400,0x0000},
   {"",0,0,0}
};

ROMSTRUCT pengosnd[]=
{
   {"pr1635.051",0x0000,0x0100,0x0000},
   {"pr1636.070",0x0100,0x0100,0x0000},
   {"",0,0,0}
};

INPUTS pengoinputs[]=
{
   {K_PL1_UP,0x90c0,0x01,0,0},
   {K_PL1_DOWN,0x90c0,0x02,0,0},
   {K_PL1_LEFT,0x90c0,0x04,0,0},
   {K_PL1_RIGHT,0x90c0,0x08,0,0},
   {K_COIN1,0x90c0,0x10,0,2},
   {K_COIN2,0x90c0,0x20,0,2},
   {K_COIN3,0x90c0,0x40,0,2},
   {K_PL1_B1,0x90c0,0x80,0,0},

   {K_PL2_UP,0x9080,0x01,0,0},
   {K_PL2_DOWN,0x9080,0x02,0,0},
   {K_PL2_LEFT,0x9080,0x04,0,0},
   {K_PL2_RIGHT,0x9080,0x08,0,0},
   {K_NO_MATCH,0x9080,0x10,0,0},
   {K_PL1_START,0x9080,0x20,0,0},
   {K_PL2_START,0x9080,0x40,0,0},
   {K_PL2_B1,0x9080,0x80,0,0},
   {-1,-1,0,0,0}
};




GFXDETAILS pengogfxs[]=
{
   {0,0,8,8,&pacclayout,0,TYPE_CHAR},
   {0x1000,0,16,16,&pacslayout,0,TYPE_SPR},
   {0x2000,256,8,8,&pacclayout,1,TYPE_CHAR},
   {0x3000,64,16,16,&pacslayout,1,TYPE_SPR},
   {-1,0,0,0,0,0,0}
};


#define PENGODIPS \
   { \
   {1,0,0,0,0, \
      { \
         {DIP_BONUS,1,0, \
            { \
               {"30000",0,0},{"50000",0,1} \
            } \
         }, \
         {DIP_SOUNDS,2,0, \
            { \
               {DIP_ON,0,0},{DIP_OFF,0,2} \
            } \
         }, \
         {DIP_CABINET,0,0, \
            { \
               {DIP_UPRIGHT,0,0},{DIP_COCKTAIL,0,4} \
            } \
         }, \
         {DIP_LIVES,0x10,0, \
            { \
               {"2",0,0x18},{"3",0,0x10},{"4",0,0x08},{"5",0,0x00} \
            } \
         }, \
         {DIP_RACK,0x20,0, \
            { \
               {DIP_ON,0,0},{DIP_OFF,0,0x20}\
            } \
         }, \
         {DIP_DIFFICULTY,0x80,0, \
            { \
               {DIP_EASY,0,0xc0},{DIP_NORMAL,0,0x80},{DIP_HARD,0,0x40},{DIP_HARDEST,0,0x00}\
            } \
         }, \
      } \
   }, \
   {2,0,0,0,0, \
      { \
         {DIP_COINA,0x0c,0, \
            { \
               {DIP_4C_1C,0,0x00},{DIP_3C_1C,0,0x08},{DIP_2C_1C,0,0x04},{"2C / 1Cred 5/3",0,0x09}, \
               {"2C / 1Cred 4/3",0,0x05},{DIP_1C_1C,0,0x0c},{"1C / 1Cred 5/6",0,0x0d}, \
               {"1C / 1Cred 4/5",0,0x03},{"1C / 1Cred 2/3",0,0x0b},{DIP_1C_2C,0,0x02}, \
               {"1C / 2Cred 5/11",0,0x07},{"1C / 2Cred 4/9",0,0x0f},{DIP_1C_3C,0,0x0a}, \
               {DIP_1C_5C,0,0x06},{DIP_1C_5C,0,0x0e},{DIP_1C_6C,0,0x01} \
            } \
         }, \
         {DIP_COINB,0xc0,0, \
            { \
               {DIP_4C_1C,0,0x00},{DIP_3C_1C,0,0x80},{DIP_2C_1C,0,0x40},{"2C / 1Cred 5/3",0,0x90}, \
               {"2C / 1Cred 4/3",0,0x50},{DIP_1C_1C,0,0xc0},{"1C / 1Cred 5/6",0,0xd0}, \
               {"1C / 1Cred 4/5",0,0x30},{"1C / 1Cred 2/3",0,0xb0},{DIP_1C_2C,0,0x20}, \
               {"1C / 2Cred 5/11",0,0x70},{"1C / 2Cred 4/9",0,0xf0},{DIP_1C_3C,0,0xa0}, \
               {DIP_1C_5C,0,0x60},{DIP_1C_5C,0,0xe0},{DIP_1C_6C,0,0x10} \
            } \
         } \
      } \
   } \
   }

#endif
