#include "main.h"
#include "phnxsnd.h"
#include "globals.h"

static int wave1,soundafreq,soundbfreq,soundavol,soundbvol;
static int hifreq,hifreq_trip;
static int amod,bmod;
static int adjustb=1;
static fixed moddepth;
static fixed sweepdepth;

PHX_SINEWAVE
PHX_SINE_LOOKUP

void phoenixsetupsound(void)
{
//create a sinewave sample
   createsample(sinewave,32,&wave1,TRUE);
   phoenixstartsound();
//setup fixed point modulation/sweep values
   moddepth=float2fixed(MOD_DEPTH);
   sweepdepth=float2fixed(SWEEP_DEPTH);
}

void phoenixstartsound(void)
{
//and set them going
   setvol(0,0);
   setvol(1,0);
   playsample(0,wave1,LOOP,DEFAULT_FREQ);
   playsample(1,wave1,LOOP,DEFAULT_FREQ);
}

void phoenixsndaw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   static int curnoise=0;
   int noise=(value&0xc0)>>6;
   int freq=value&0x0f;
   int pvol=(value&0x30)>>4;



   if(freq!=0x0f)
	{
      soundavol=pvol;
      soundafreq=freq;
	}
	else
      soundavol=3;

   if(noise&&curnoise!=noise)
      playsample(2,(noise-1)+1,ONE_SHOT,DEFAULT_FREQ);
   curnoise=noise;
}

void phoenixsndbw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   static int curtune=0;
   int tune=(value&0xc0)>>6;


   int freq=value&0x0f;
   int pvol=(value& 0x30)>>4;



   adjustb=(freq!=soundbfreq);

   if(freq!=0x0f)
	{
      soundbvol=pvol;
      soundbfreq=freq;
	}
	else
      soundbvol=3;


   if(tune>1&&tune!=curtune)
      playsample(3,(tune+1),ONE_SHOT,DEFAULT_FREQ);
   curtune=tune;
}

void phoenixupdatesound(void)
{
   int sa,sb;
   fixed fpa,fpb,fpwork;

//work out the 2 volumes
   sa=10*(3-soundavol)/3;
   sb=5*(3-soundbvol)/3;

//only do the pitch calc if we have to
   if(sa)
   {
      fpa=int2fixed(14000/(16-soundafreq));

      if(hifreq)
      {
         fpa=fixedmul(fpa,5);
         fpa=fixeddiv(fpa,4);
      }
      fpwork=fixedmul(fpa,moddepth);
      fpa+=fixedmul(fpwork,sintable[amod]);
      setfreq(0,fixed2int(fpa));
   }

//hifreq trip
   hifreq_trip++;
   if(hifreq_trip==HI_INTERVAL)
	{
		hifreq=!hifreq;
      hifreq_trip=0;
	}

//modulation of channel a
   amod++;
   if(amod==MAX_AMOD)
      amod=0;

//only do the pitch calc if we have to
   if(sb)
   {
      fpb=int2fixed(8000/(16-soundbfreq));
      fpwork=fixedmul(fpb,sweepdepth);
      fpb+=fixedmul(fpwork,sintable[bmod]);
      setfreq(1,fixed2int(fpb));
   }

//modulation of channel b
   if(adjustb)
      bmod=0;
   bmod++;
   if(bmod>MAX_BMOD)
      bmod=MAX_BMOD;

//finally, set the volume of the 2 outputs
   setvol(0,sa);
   setvol(1,sb);
}
