#ifndef _POOYANBRD
#define _POOYANBRD


ROMSTRUCT pooyancode[]=
{
   {"1.4a",0x0000,0x2000,0x0000},
   {"2.5a",0x2000,0x2000,0x0000},
   {"3.6a",0x4000,0x2000,0x0000},
   {"4.7a",0x6000,0x2000,0x0000},
   {"",0,0,0}
};


ROMSTRUCT pooyangfx[]=
{
   {"8.10g",0x0000,0x1000,0x0000},
   {"7.9g",0x1000,0x1000,0x0000},
   {"6.9a",0x2000,0x1000,0x0000},
   {"5.8a",0x3000,0x1000,0x0000},
   {"",0,0,0}
};

ROMSTRUCT pooyancol[]=
{
   {"pooyan.pr1",0x0000,0x0020,0x0000},
   {"pooyan.pr2",0x0020,0x0100,0x0000},
   {"pooyan.pr3",0x0120,0x0100,0x0000},
   {"",0,0,0}
};

ROMSTRUCT pooyansndcode[]=
{
   {"xx.7a",0x0000,0x1000,0x0000},
   {"xx.8a",0x1000,0x1000,0x0000},
   {"",0,0,0}
};


INPUTS pooyaninputs[]=
{
   {K_COIN1,0xa080,0x01,0,0},
   {K_COIN2,0xa080,0x02,0,0},
   {K_COIN3,0xa080,0x04,0,0},
   {K_PL1_START,0xa080,0x08,0,0},
   {K_PL2_START,0xa080,0x10,0,0},
   {K_NO_MATCH,0xa080,0x20,0,0},
   {K_NO_MATCH,0xa080,0x40,0,0},
   {K_NO_MATCH,0xa080,0x80,0,0},
   {K_NO_MATCH,0xa0a0,0x01,0,0},
   {K_NO_MATCH,0xa0a0,0x02,0,0},
   {K_PL1_UP,0xa0a0,0x04,0,0},
   {K_PL1_DOWN,0xa0a0,0x08,0,0},
   {K_PL1_B1,0xa0a0,0x10,0,0},
   {K_NO_MATCH,0xa0a0,0x20,0,0},
   {K_NO_MATCH,0xa0a0,0x40,0,0},
   {K_NO_MATCH,0xa0a0,0x80,0,0},
   {K_NO_MATCH,0xa0c0,0x01,0,0},
   {K_NO_MATCH,0xa0c0,0x02,0,0},
   {K_PL2_UP,0xa0c0,0x04,0,0},
   {K_PL2_DOWN,0xa0c0,0x08,0,0},
   {K_PL2_B1,0xa0c0,0x10,0,0},
   {K_NO_MATCH,0xa0a0,0x20,0,0},
   {K_NO_MATCH,0xa0a0,0x40,0,0},
   {K_NO_MATCH,0xa0a0,0x80,0,0},
   {-1,-1,0,0,0}
};


//layout of chars
SPRLAYOUT pyanclayout={16,256,4,{4,0,0x1000*8+4,0x1000*8+0,0,4},{3,2,1,0,8*8+3,8*8+2,8*8+1,8*8+0},
                           {0,1,2,3,4,5,6,7},16};

//layout of sprites
SPRLAYOUT pyanslayout={16,64,4,{4,0,0x1000*8+4,0x1000*8+0},
   {3,2,1,0,8*8+3,8*8+2,8*8+1,8*8+0,16*8+3,16*8+2,16*8+1,16*8+0,24*8+3,24*8+2,24*8+1,24*8+0},
   {0,1,2,3,4,5,6,7,32,33,34,35,36,37,38,39},64};

GFXDETAILS pyangfxs[]=
{
   {0,0,8,8,&pyanclayout,0,TYPE_CHAR},
   {0x2000,0,16,16,&pyanslayout,1,TYPE_SPR},
   {-1,0,0,0,0,0,0}
};




#define PYANDIPS \
   { \
   {1,0,0,0,0, \
      { \
         {DIP_COINA,0x0f,0, \
            { \
               {DIP_4C_1C,0,0x02},{DIP_3C_1C,0,0x05},{DIP_2C_1C,0,0x08}, \
               {DIP_3C_2C,0,0x04},{DIP_4C_3C,0,0x01},{DIP_1C_1C,0,0x0f}, \
               {DIP_3C_4C,0,0x03},{DIP_2C_3C,0,0x07},{DIP_1C_2C,0,0x0e}, \
               {DIP_2C_5C,0,0x06},{DIP_1C_3C,0,0x0d},{DIP_1C_4C,0,0x0c}, \
               {DIP_1C_5C,0,0x0b},{DIP_1C_6C,0,0x0a},{DIP_1C_7C,0,0x09}, \
               {DIP_FREE,0,0} \
            } \
         }, \
         {DIP_COINB,0xf0,0, \
            { \
               {DIP_4C_1C,0,0x20},{DIP_3C_1C,0,0x50},{DIP_2C_1C,0,0x80}, \
               {DIP_3C_2C,0,0x40},{DIP_4C_3C,0,0x10},{DIP_1C_1C,0,0xf0}, \
               {DIP_3C_4C,0,0x30},{DIP_2C_3C,0,0x70},{DIP_1C_2C,0,0xe0}, \
               {DIP_2C_5C,0,0x60},{DIP_1C_3C,0,0xd0},{DIP_1C_4C,0,0xc0}, \
               {DIP_1C_5C,0,0xb0},{DIP_1C_6C,0,0xa0},{DIP_1C_7C,0,0x90}, \
               {DIP_FREE,0,0} \
            } \
         } \
      } \
   }, \
   {2,0,0,0,0, \
      { \
         {DIP_LIVES,3,0, \
            { \
               {"3",0,3},{"4",0,2},{"5",0,1},{"255",0,0} \
            } \
         }, \
         {DIP_CABINET,0,0, \
            { \
               {DIP_UPRIGHT,0,0},{DIP_COCKTAIL,0,4} \
            } \
         }, \
         {DIP_BONUS,8,0, \
            { \
               {"50000 80000",0,8},{"30000 70000",0,0} \
            } \
         }, \
         {DIP_DIFFICULTY,0x40,0, \
            { \
               {DIP_EASIEST,0,0x70},{DIP_EASIER,0,0x60},{DIP_EASY,0,0x50}, \
               {DIP_NORMAL,0,0x30},{DIP_MEDIUM,0,0x60},{DIP_DIFFICULT,0,0x50}, \
               {DIP_HARD,0,0x10},{DIP_HARDEST,0,0} \
            } \
         }, \
         {DIP_SOUNDS,0x80,0, \
            { \
               {DIP_OFF,0,0x80},{DIP_ON,0,0x00} \
            } \
         }, \
      } \
   } \
   }

#endif
