#ifndef _SCRAM_MEM_H_
#define _SCRAM_MEM_H_

struct MemoryWriteByte ScrambleWrite[] =
{
   {0x0000,0x3fff,romwrite,NULL},
   {0x6803,0x6803,scramback,NULL},
   {0x6807,0x6807,flipscreenw,NULL},
   {0x8200,0x8200,sound_command_w,NULL},
   {0x8201,0x8201,scramsndirq,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};


struct MemoryReadByte ScrambleRead[] =
{
   {0x8101,0x8101,dip1,NULL},
   {0x8102,0x8102,dip2,NULL},
   {0x8202,0x8202,scramprotread,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryReadByte AtlantisRead[] =
{
   {0x8101,0x8101,dip1,NULL},
   {0x8102,0x8102,dip2,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryReadByte ScrambleSndRead[] =
{
   {(UINT32)0xffffffff,(UINT32)0xfffffff, NULL,NULL}
};

struct MemoryWriteByte ScrambleSndWrite[] =
{
   {0x0000,0x1fff,romwrite,NULL},
   {(UINT32)0xffffffff,(UINT32)0xfffffff, NULL,NULL}
};

struct MemoryWriteByte TriplePWrite[] =
{
   {0x0000,0x3fff,romwrite,NULL},
   {0x4c00,0x4fff,triplepmir,NULL},
   {0x6803,0x6803,romwrite,NULL},
   {0x6807,0x6807,flipscreenw,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};


struct z80PortRead ScrambleSndReadPorts[] =
{
   {0x20,0x20,AY8910_read_port_1_r,NULL},
   {0x80,0x80,AY8910_read_port_0_r,NULL},
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};

struct MemoryReadByte HotshockRead[] =
{
   {0x4c00,0x4fff,vidmirror,NULL},  /* mirror address */
   {0x8002,0x8002,dip1,NULL},
   {0x8003,0x8003,dip2,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};


struct MemoryWriteByte HotshockWrite[] =
{
   {0x0000,0x3fff,romwrite,NULL},
   {0x6004,0x6004,flipscreenw,NULL},
   {0x6006,0x6006,unigfxbankw,NULL},
   {0x8000,0x8000,sound_command_w,NULL},
   {0x9000,0x9000,hotshocksndirq,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct z80PortWrite ScrambleSndWritePorts[] =
{
   {0x10,0x10,AY8910_control_port_1_w,NULL},
   {0x20,0x20,AY8910_write_port_1_w,NULL},
   {0x40,0x40,AY8910_control_port_0_w,NULL},
   {0x80,0x80,AY8910_write_port_0_w,NULL},
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};

struct z80PortWrite HotshockSndWritePorts[] =
{
   {0x10,0x10,AY8910_control_port_1_w,NULL},
   {0x20,0x20,AY8910_write_port_1_w,NULL},
   {0x40,0x40,AY8910_write_port_0_w,NULL},
   {0x80,0x80,AY8910_control_port_0_w,NULL},
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};

struct z80PortRead HotshockSndReadPorts[] =
{
   {0x20,0x20,AY8910_read_port_1_r,NULL},
   {0x40,0x40,AY8910_read_port_0_r,NULL},
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};


struct z80PortRead TriplePReadPorts[]=
{
   {0x01,0x01,AY8910_read_port_0_r,NULL},
   {0x02,0x02,triplep_pip,NULL},
   {0x03,0x03,triplep_pap,NULL},
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};


struct z80PortWrite TriplePWritePorts[] =
{
   {0x01,0x01,AY8910_control_port_0_w,NULL},
   {0x00,0x00,AY8910_write_port_0_w,NULL},
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};


struct MemoryWriteByte DevilFishWrite[] =
{
   {0x0000,0x3fff,romwrite,NULL},
   {0x5080,0x50ff,romwrite,NULL},
   {0x680b,0x680b,flipscreenw,NULL},
   {0x8200,0x8200,sound_command_w,NULL},
   {0x8202,0x8202,scramsndirq,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryReadByte DevilFishRead[] =
{
   {0x4c00,0x4fff,vidmirror,NULL},
   {0x8102,0x8102,dip1,NULL},
   {0x8108,0x8108,dip2,NULL},
   {0x8208,0x8208,devilnon,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};


#endif
