#ifndef _SN76496_H_
#define _SN76496_H_

#define MAX_76496 4

struct SN76496
{
	int SampleRate;
	unsigned int UpdateStep;
	int VolTable[16];	/* volume table         */
	int Register[8];	/* registers */
	int LastRegister;	/* last register written */
	int Volume[4];		/* volume of voice 0-2 and noise */
	unsigned int RNG;		/* noise generator      */
	int NoiseFB;		/* noise feedback mask */
	int Period[4];
	int Count[4];
	int Output[4];
};

struct SN76496interface
{
	int num;	/* total number of 76496 in the machine */
	int baseclock[MAX_76496];
	int volume[MAX_76496];
};

int SN76496_sh_start(const struct SN76496interface *intf);
void SN76496partupdate(int chip);
void SN76496_sh_update(void);

void SN76496_0_w(UINT32 offset,UINT8 value,struct MemoryWriteByte * mwb);
void SN76496_1_w(UINT32 offset,UINT8 value,struct MemoryWriteByte * mwb);
void SN76496_2_w(UINT32 offset,UINT8 value,struct MemoryWriteByte * mwb);
void SN76496_3_w(UINT32 offset,UINT8 value,struct MemoryWriteByte * mwb);
void SN76496_0_pw(UINT16 offset, UINT8 value, struct z80PortWrite *zpw);
void SN76496_1_pw(UINT16 offset, UINT8 value, struct z80PortWrite *zpw);
void SN76496_2_pw(UINT16 offset, UINT8 value, struct z80PortWrite *zpw);
void SN76496_3_pw(UINT16 offset, UINT8 value, struct z80PortWrite *zpw);


#endif
