#ifndef _SOUND_H_
#define _SOUND_H_

#define  DEFAULT_FREQ 1000
#define  LOOP        99
#define  ONE_SHOT    0

#define  NO_CHANNELS    12
#define  NO_VOL_STEPS   16
#define  NO_SAMPLES     32

#define  MAX_SAMPLE_LEN 524287L

#define  SAMPLE_11025   0
#define  SAMPLE_22050   1
#define  SAMPLE_44100   2

#define SAMPLESSOFAR    (int)(actsamples*getcyclesthisframe())/getcyclesperframe()

typedef struct streamTAG
{
   int bUpdated;
   int nVol;
   pBYTE pStreamUpdate;
} STREAM;

typedef STREAM *pSTREAM;

typedef struct sampitemTAG
{
   LPAUDIOWAVE lpWave;
   void *pNext;
} SAMPITEM;

typedef SAMPITEM *pSAMPITEM;

typedef struct samplistTAG
{
   pSAMPITEM pHead;
} SAMPLIST;

typedef SAMPLIST *pSAMPLIST;


typedef struct channelTAG
{
   int paused;
   int syspaused;
   int playing;
   int sampleno;
   int looping;
   int vol;
   int freq;
   int queuechannel;
   int queueno;
   int queueloop;
   int queuefreq;
} CHANNEL;

typedef CHANNEL * pCHANNEL;

#define CHANNEL_NO (cno+basechannel)

#define CHANNEL_CHECK \
   if(CHANNEL_NO>=NO_CHANNELS) \
      return;

#define SILENCE_CHECK \
   if(soundcard==0) \
      return;

#define LOAD_CHECK \
   if(!sampleloaded[sampleno]) \
      return;

//Sound functions
void updatesound(void);
void playsample(int channel,int sampleno,int looping,int freq);
int initsound(int streams);
void clearchannels(void);
int readsample(pBYTE buf,DWORD len);
void play1sample(int cno,int sampleno,int looping,int freq);
void stopsample(int channel);
int createsample(pBYTE pData,int len,int *no,int loop);
pBYTE createemptysample(int len,int *no,int loop);
void queuesample(int cno,int sampleno,int looping,int freq);
void queuesampleext(int cno,int cnoext,int sampleno,int looping,int freq);
void setvol(int cno,int invol);
void setfreq(int cno,int freq);
void setstreamfreq(int cno,int freq);
void setstreamfreqHz(int cno,int freq);
void clearsound(void);
void initsoundinterface(void);
int updatevolume(void);
void addsampleq(pSAMPITEM pSampItem,int nIdx);
void playq(int cno,pSAMPITEM pSampItem);
void pausesample(int cno);
void resumesample(int cno);
void pauseallsamples(void);
void resumeallsamples(void);
void updateDMA(int idx);
void getvoicepos(int idx,LONG *ppos);

void startstreams(void);
void stopstreams(void);
void calcrealsamprate(void);
void updatestreams(void);

int sndlatchread(void);
UINT16 sndlatchportr(UINT16 offset, struct z80PortRead *zpr);
int sound_command_r(void);
void sound_command_w(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
void playstreamedsample(int channel,signed char *data,int len,int vol);
int getsamplessofar(void);
void setblanksample(void);


#endif
