#ifndef _UI_H_
#define _UI_H_

#define MENU_ACTION        1
#define MENU_INT_VALUE     2
#define MENU_YESNO_VALUE   4
#define MENU_NOYES_VALUE   8
#define MENU_TEXT_VALUE    16
#define MENU_TEXT_STRING   32
#define MENU_FIXED_INT     64

#define DEFAULT_KEYS       0
#define GAME_KEYS          1


typedef struct menuitemTAG
{
   char  szDisplay[32];
   int   nType;
   int (*itemproc)(void);
   int *value;
   char *pvalue;
   int min;
   int max;
   int dipswitch;
   int dipsub;
   int dipidx;
   int waitstate;
   int (*waitproc)(void);
} MENUITEM;

typedef struct menuTAG
{
   int noitems;
   int offset;
   MENUITEM menuitem[64];
} MENU;

typedef MENU *pMENU;

int resetgame(void);

int exitmain(void);
int exitsub(void);

void initui(void);
void clearui(void);
void uireadkeys(void);
int loadfont(void);
void clearfont(void);
void uipal(void);
void uidispcentrestring(int y,char *data,int color);
void uidispstring(int x,int y,char *data,int color);
void uidispchar(int x,int y,BYTE data,int color);
void uisetpal(void);
void uirestorepal(void);
void uidispmenu(void);
void uimovecursor(void);
int createdipmenu(void);
int updatedipsetting(void);
void menuclear(void);
void markalldirty(void);
int createdefkeymenu(void);
int createthiskeymenu(void);
int createkeymenu(int mtype);
int choosekey(void);
int waitkey(void);
int centervalchange(void);
int createtweakmenu(void);
int totalchange(void);
void updaterates(void);
int restoretweakdefs(void);
int exitnosave(void);
int exitsave(void);
void baseuipal(void);
void showfps(int fps);
int createdefjoymenu(void);
int createthisjoymenu(void);
int createjoymenu(int mtype);
int joychange(void);
int updatepause(void);

#endif
