#ifndef _UI_LC_H
#define _UI_LC_H

extern int vol;
extern int throttle;
extern int background;
extern int vsync;

static char yesno[2][4]={{"No"},{"Yes"}};
static char curhzrate[16];
static char curvtrate[16];
static char VESABanner[16]="for VESA modes";
static int htotal;
static int vtotal;
static int wrkcentx;
static int wrkcenty;


//joystick button names
static char joydisp[][16]=
{
   "Joy1 B1","Joy1 B2","Joy1 B3","Joy1 B4","Joy1 B5","Joy1 B6","Joy1 B7","Joy1 B8","Joy1 Select","Joy1 Start",
   "Joy2 B1","Joy2 B2","Joy2 B3","Joy2 B4","Joy2 B5","Joy2 B6","Joy2 B7","Joy2 B8","Joy2 Select","Joy2 Start"
};

static MENU mainmenu=
{
   11,0,
   {
      {"Dip Switches",MENU_ACTION,createdipmenu,0,0,0,0,0,0,0,0,0},
      {"Default Keys",MENU_ACTION,createdefkeymenu,0,0,0,0,0,0,0,0,0},
      {"Keys This Game",MENU_ACTION,createthiskeymenu,0,0,0,0,0,0,0,0,0},
      {"Default Joystick",MENU_ACTION,createdefjoymenu,0,0,0,0,0,0,0,0,0},
      {"Joystick This Game",MENU_ACTION,createthisjoymenu,0,0,0,0,0,0,0,0,0},
      {"VSync Display",MENU_YESNO_VALUE,0,&vsync,0,0,1,0,0,0,0,0},
      {"Tweak Display",MENU_ACTION,createtweakmenu,0,0,0,0,0,0,0,0,0},
      {"Volume",MENU_INT_VALUE,updatevolume,&vol,0,0,15,0,0,0,0,0},
      {"Throttle",MENU_YESNO_VALUE,0,&throttle,0,0,1,0,0,0,0,0},
      {"Pause",MENU_YESNO_VALUE,updatepause,&syspaused,0,0,1,0,0,0,0,0},
      {"Reset Game",MENU_ACTION,resetgame,0,0,0,0,0,0,0,0,0},
      {"",MENU_ACTION,0,0,0,0,0,0,0,0,0,0},
      {"",MENU_ACTION,0,0,0,0,0,0,0,0,0,0}
   }
};

static MENU tweakmenu=
{
   9,0,
   {
      {"Center X",MENU_INT_VALUE,centervalchange,&wrkcentx,0,-32,32,0,0,0,0,0},
      {"Center Y",MENU_INT_VALUE,centervalchange,&wrkcenty,0,-32,32,0,0,0,0,0},
      {"Horizontal Total",MENU_INT_VALUE,totalchange,&htotal,0,0,255,0,0,0,0,0},
      {"Vertical Total",MENU_INT_VALUE,totalchange,&vtotal,0,0,255,0,0,0,0,0},
      {"[scan rate",MENU_ACTION|MENU_TEXT_STRING,0,0,curhzrate,0,0,0,0,0,0,0},
      {"[refresh rate",MENU_ACTION|MENU_TEXT_STRING,0,0,curvtrate,0,0,0,0,0,0,0},
      {"Undo Changes",MENU_ACTION,restoretweakdefs,0,0,0,0,0,0,0,0,0},
      {"Exit with no Save",MENU_ACTION,exitnosave,0,0,0,0,0,0,0,0,0},
      {"Exit and Save",MENU_ACTION,exitsave,0,0,0,0,0,0,0,0,0}
   }
};

static MENU VEAStweakmenu=
{
   2,0,
   {
      {"N/A",MENU_ACTION|MENU_TEXT_STRING,0,0,VESABanner,0,0,0,0,0,0,0},
      {"Exit",MENU_ACTION,exitnosave,0,0,0,0,0,0,0,0,0},
   }
};

static MENUITEM backmenuitem={"Background",MENU_YESNO_VALUE,0,&background,0,0,1,0,0,0,0,0};
static MENUITEM exitmenuitem={"Return to Game",MENU_ACTION,exitmain,0,0,0,0,0,0,0,0,0};

#endif
