#include "main.h"
#include "globals.h"
#include "twk.h"

pBYTE pCharMem;
pBYTE pAttrMem;

BYTE collookups[8][1024];

void donothingmod(int *spr);

pBYTE pMask;
int opqcol;
extern int dsize;
extern int *dpage[4];
int xmove,ymove,outoff;
static int attemptflip;
int gendirty[48][48];

#define LKSPRITELINE \
   val=lk[(*(pWork2++))|precol]; \
   if(val) \
      *pWork=val; \
   pWork+=xmove;



void markgendirty(int x,int y)
{
   int idx;
   int x1,y1;
   static int xoff[]={-1,0,1,-1,0,1,-1,0,1};
   static int yoff[]={0,0,0,1,1,1,2,2,2};

   static int xoff2[]={0,1,2,0,1,2,0,1,2};
   static int yoff2[]={0,0,0,1,1,1,2,2,2};

   x>>=3;
   y>>=3;


   if(realorient)
   {
      for(idx=0;idx<9;idx++)
         gendirty[x+xoff2[idx]][y+yoff2[idx]]=-1;
   }
   else
   {
      for(idx=0;idx<9;idx++)
        gendirty[x+xoff[idx]][y+yoff[idx]]=-1;
   }
}

void initgfx(void)
{
   int i,j;
   sprmodify=donothingmod;

//init lookups to 1 to 1
   for(i=0;i<8;i++)
   {
      for(j=0;j<1024;j++)
         collookups[i][j]=j&0xff;
   }
   memset(gendirty,0,sizeof(int)*48*48);
}

void readgfxs(pBYTE pIn,int nType)
{
   int i;

   PRECALC_RETURN

   i=0;
   if(pBoard->gfxdetails)
   {
      while(pBoard->gfxdetails[i].startoffset!=-1)
         decodespr(&pBoard->gfxdetails[i++],pIn);
   }
}


void decodespr(pGFXDETAILS pGfxDetails,pBYTE pIn)
{
   pBYTE pWork;
   pBYTE pWork2;
   pBYTE pWork3;
   pBYTE pWork4;
   pBYTE pMask=0; //keep compiler happy
   pBYTE pLookup;
   int *pTempWork;
   int *pColWork;
   int work;
   BYTE cAnd;
   int shifter,xyoffset;
   int col,plane,precol,cindex,x,y;


   pTempWork=myalloc(sizeof(int)*pGfxDetails->pSprLayout->total*pGfxDetails->xsize*pGfxDetails->ysize);


   if(pGfxDetails->lookupidx>=0)
      pLookup=collookups[pGfxDetails->lookupidx];
   else
      pLookup=0;

   pIn+=pGfxDetails->startoffset;
   xyoffset=pGfxDetails->xsize*pGfxDetails->ysize;

   for(col=0;col<pGfxDetails->pSprLayout->nocols;col++)
   {
      for(plane=0;plane<pGfxDetails->pSprLayout->noplanes;plane++)
      {
         if(pGfxDetails->pSprLayout->planeoffsets[plane]>=0)
         {
            pColWork=pTempWork;
            switch(pGfxDetails->nType)
            {
               default:
                  pWork=&Gfx[COL_CHAR+(pGfxDetails->coffset*xyoffset)];
                  pMask=&Mask[pGfxDetails->coffset*xyoffset];
                  break;
               case TYPE_SPR:
                  pWork=&Sprites[COL_SPRITE+(pGfxDetails->coffset*xyoffset)];
                  break;
               case TYPE_BIG:
                  pWork=&BigSprites[COL_BIG+(pGfxDetails->coffset*xyoffset)];
                  break;
               case TYPE_TILE:
                  pWork=&Tiles[COL_TILE+(pGfxDetails->coffset*xyoffset)];
                  break;
            }

            precol=(1<<plane)+(col<<pGfxDetails->pSprLayout->noplanes);

            shifter=pGfxDetails->pSprLayout->planeoffsets[plane]&7;

            for(cindex=0;cindex<pGfxDetails->pSprLayout->total;cindex++)
            {
               pWork2=pIn+pGfxDetails->pSprLayout->sproff*cindex;
               pWork2+=(pGfxDetails->pSprLayout->planeoffsets[plane]>>3);
               for(y=0;y<pGfxDetails->ysize;y++)
               {
                  pWork3=pWork2+pGfxDetails->pSprLayout->yoffsets[y];
                  for(x=0;x<pGfxDetails->xsize;x++,pWork++,pMask++,pColWork++)
                  {
                     pWork4=pWork3+(pGfxDetails->pSprLayout->xoffsets[x]>>3);
                     work=pGfxDetails->pSprLayout->xoffsets[x]&7;
                     work+=shifter;
                     cAnd=(1<<work);
                     if(!plane)
                        *pColWork=0;
                     if(*pWork4&cAnd)
                     {
                        *pWork|=precol;
                        *pColWork|=precol;
                        if(!pLookup)
                        {
                           if(pGfxDetails->nType==TYPE_CHAR)
                              *pMask=0;
                        }
                     }
                     if(pLookup)
                     {
                        if(plane==(pGfxDetails->pSprLayout->noplanes-1))
                           *pWork=pLookup[*pColWork];
                        if(*pWork&&pGfxDetails->nType==TYPE_CHAR)
                           *pMask=0;
                     }
                  }
               }
            }
         }
      }
   }
   myfree(pTempWork);
}

void dispopqchar(int x,int y,int value,BYTE col)
{
   pBYTE pWork;
   int dummy1,dummy2,dummy3,dummy4,dummy5;
   int dirt;
   int dirtval;

   if(x<0||y<0)
      return;
   dirtval=value|(int)(col<<8);


   if(pBoard->dirtyupd&&gendirty[(x>>3)+4][(y>>3)+4]==dirtval)
      return;

   DIRTYCHAR

   if(pBoard->dirtyupd)
      gendirty[(x>>3)+4][(y>>3)+4]=dirtval;

   opqcol=col<<2;


   if(FlipScreen)
      pWork=&FlipGfx[COL_CHAR+(value<<6)];
   else
      pWork=&Gfx[COL_CHAR+(value<<6)];



	__asm__ __volatile__
	(
		".align 4 \n"
//save es and set our selector
		"pushw		%%es	\n"
      "movw    %%ax,%%es \n"
//x,y
      "movl    $32,%%eax \n"
      "addl    %%eax,%%ebx \n"
      "addl    %%eax,%%ecx \n"
      "addl    %%ebx,%%edi \n"
      "shll    $9,%%ecx \n"
      "addl    %%ecx,%%edi \n"

      "movl    $508,%%edx \n"

      "movl    _opqcol,%%ebx \n"
      "movb    %%bl,%%bh \n"
      "movl    %%ebx,%%ecx \n"
      "shll    $16,%%ebx \n"
      "movw    %%cx,%%bx \n"

//blit line
      "movl    (%%esi),%%eax \n"
      "orl     %%ebx,%%eax \n"
      "movl    %%eax,(%%edi) \n"

      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"

      "movl    (%%esi),%%eax \n"
      "orl     %%ebx,%%eax \n"
      "movl    %%eax,(%%edi) \n"

      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "orl     %%ebx,%%eax \n"
      "movl    %%eax,(%%edi) \n"

      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"

      "movl    (%%esi),%%eax \n"
      "orl     %%ebx,%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "orl     %%ebx,%%eax \n"
      "movl    %%eax,(%%edi) \n"

      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"

      "movl    (%%esi),%%eax \n"
      "orl     %%ebx,%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "orl     %%ebx,%%eax \n"
      "movl    %%eax,(%%edi) \n"

      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"

      "movl    (%%esi),%%eax \n"
      "orl     %%ebx,%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "orl     %%ebx,%%eax \n"
      "movl    %%eax,(%%edi) \n"

      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"

      "movl    (%%esi),%%eax \n"
      "orl     %%ebx,%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "orl     %%ebx,%%eax \n"
      "movl    %%eax,(%%edi) \n"

      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"

      "movl    (%%esi),%%eax \n"
      "orl     %%ebx,%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "orl     %%ebx,%%eax \n"
      "movl    %%eax,(%%edi) \n"

      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"

      "movl    (%%esi),%%eax \n"
      "orl     %%ebx,%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "orl     %%ebx,%%eax \n"
      "movl    %%eax,(%%edi) \n"

      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"

      "movl    (%%esi),%%eax \n"
      "orl     %%ebx,%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"

      "popw    %%es \n"


//outputs (clobbered inputs)
		: "=a" (dummy1),
        "=S" (dummy2),
        "=D" (dummy3),
        "=b" (dummy4),
        "=c" (dummy5)
// inputs -
      :"0" (DataSeg),
       "1" (pWork),
       "2" (pScreen),
       "3" (x),
       "4" (y)
// registers modified
      :  "dx","cc", "memory"
	);

}


int dispchar(int x,int y,int value,BYTE col)
{
   pBYTE pWork;
   int dummy1,dummy2,dummy3,dummy4,dummy5;
   int dirt;
   int dirtval;

   if(x<0||y<0)
      return FALSE;
   dirtval=value|(int)(col<<8);


   if(pBoard->dirtyupd&&gendirty[(x>>3)+4][(y>>3)+4]==dirtval)
      return FALSE;;

   DIRTYCHAR

   if(pBoard->dirtyupd)
      gendirty[(x>>3)+4][(y>>3)+4]=dirtval;

   if(FlipScreen)
      pWork=&FlipGfx[COL_CHAR+(value<<6)];
   else
      pWork=&Gfx[COL_CHAR+(value<<6)];



	__asm__ __volatile__
	(
		".align 4 \n"
//save es and set our selector
		"pushw		%%es	\n"
      "movw    %%ax,%%es \n"
//x,y
      "movl    $32,%%eax \n"
      "addl    %%eax,%%ebx \n"
      "addl    %%eax,%%ecx \n"
      "addl    %%ebx,%%edi \n"
      "shll    $9,%%ecx \n"
      "addl    %%ecx,%%edi \n"

      "movl    $508,%%edx \n"

//blit line
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
//blit line
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%edi \n"
      "movl    (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"

      "popw    %%es \n"


//outputs (clobbered inputs)
		: "=a" (dummy1),
        "=S" (dummy2),
        "=D" (dummy3),
        "=b" (dummy4),
        "=c" (dummy5)
// inputs -
      :"0" (DataSeg),
       "1" (pWork),
       "2" (pScreen),
       "3" (x),
       "4" (y)
// registers modified
      :  "dx","cc", "memory"
	);
   return TRUE;
}


void disptranschar2(int x,int y,int value,BYTE col)
{
   pBYTE pWork;
   int dummy1,dummy2,dummy3,dummy4,dummy5;
   int dirt;
   int dirtval;

   if(x<0||y<0)
      return;
   dirtval=(value-512)|(int)(col<<8);


   if(pBoard->dirtyupd&&gendirty[(x>>3)+4][(y>>3)+4]==dirtval)
      return;

   DIRTYCHAR


   if(FlipScreen)
      pWork=&FlipGfx[COL_CHAR+(value<<6)];
   else
      pWork=&Gfx[COL_CHAR+(value<<6)];



	__asm__ __volatile__
	(
		".align 4 \n"
//save es and set our selector
		"pushw		%%es	\n"
      "movw    %%ax,%%es \n"
//x,y
      "movl    $32,%%eax \n"
      "addl    %%eax,%%ebx \n"
      "addl    %%eax,%%ecx \n"
      "addl    %%ebx,%%edi \n"
      "shll    $9,%%ecx \n"
      "addl    %%ecx,%%edi \n"
      "movl    $505,%%edx \n"

      "movl    $8,%%ecx \n"
"0: \n"
//blit line
      "movb    (%%esi),%%al \n"
      "cmpb    $0,%%al \n"
      "je      1f \n"
      "movb    %%al,(%%edi) \n"
"1: \n"
      "inc     %%esi \n"
      "inc     %%edi \n"
      "movb    (%%esi),%%al \n"
      "cmpb    $0,%%al \n"
      "je      2f \n"
      "movb    %%al,(%%edi) \n"
"2: \n"
      "inc     %%esi \n"
      "inc     %%edi \n"
      "movb    (%%esi),%%al \n"
      "cmpb    $0,%%al \n"
      "je      3f \n"
      "movb    %%al,(%%edi) \n"
"3: \n"
      "inc     %%esi \n"
      "inc     %%edi \n"
      "movb    (%%esi),%%al \n"
      "cmpb    $0,%%al \n"
      "je      4f \n"
      "movb    %%al,(%%edi) \n"
"4: \n"
      "inc     %%esi \n"
      "inc     %%edi \n"
      "movb    (%%esi),%%al \n"
      "cmpb    $0,%%al \n"
      "je      5f \n"
      "movb    %%al,(%%edi) \n"
"5: \n"
      "inc     %%esi \n"
      "inc     %%edi \n"
      "movb    (%%esi),%%al \n"
      "cmpb    $0,%%al \n"
      "je      6f \n"
      "movb    %%al,(%%edi) \n"
"6: \n"
      "inc     %%esi \n"
      "inc     %%edi \n"
      "movb    (%%esi),%%al \n"
      "cmpb    $0,%%al \n"
      "je      7f \n"
      "movb    %%al,(%%edi) \n"
"7: \n"
      "inc     %%esi \n"
      "inc     %%edi \n"
      "movb    (%%esi),%%al \n"
      "cmpb    $0,%%al \n"
      "je      8f \n"
      "movb    %%al,(%%edi) \n"
"8: \n"
      "inc     %%esi \n"
//move onto next line
      "addl    %%edx,%%edi \n"
      "loop    0b \n"
      "popw    %%es \n"


//outputs (clobbered inputs)
		: "=a" (dummy1),
        "=S" (dummy2),
        "=D" (dummy3),
        "=b" (dummy4),
        "=c" (dummy5)
// inputs -
      :"0" (DataSeg),
       "1" (pWork),
       "2" (pScreen),
       "3" (x),
       "4" (y)
// registers modified
      :  "dx","cc", "memory"
	);
}

void dispflipchar(int x,int y,int value,BYTE col,int flpx,int flpy)
{
   pBYTE pWork;
   int dummy1,dummy2,dummy3,dummy4,dummy5;

   int dirtval;
   if(x<0||y<0)
      return;

   if(!flpx&&!flpy)
   {
      dispchar(x,y,value,col);
      return;
   }

   dirtval=value|(int)(col<<8);
   if(pBoard->dirtyupd&&gendirty[(x>>3)+4][(y>>3)+4]==dirtval)
      return;

   DIRTYCHAR

   if(pBoard->dirtyupd)
      gendirty[(x>>3)+4][(y>>3)+4]=dirtval;

   ymove=504;
   xmove=1;
   outoff=0;

   if(flpy)
   {
      outoff=0xe00;
      ymove=-0x208;
   }

   if(flpx)
   {
      outoff+=7;
      xmove=-1;
      ymove+=16;
   }

   if(FlipScreen)
      pWork=&FlipGfx[COL_CHAR+(value<<6)];
   else
      pWork=&Gfx[COL_CHAR+(value<<6)];


	__asm__ __volatile__
	(
		".align 4 \n"
//save es and set our selector
		"pushw		%%es	\n"
		"movw		%%ax,%%es \n"
//x,y
      "addl    $32,%%ebx \n"
      "addl    $32,%%ecx \n"
      "addl    %%ebx,%%edi \n"
      "shll    $9,%%ecx \n"
      "addl    %%ecx,%%edi \n"
      "addl    _outoff,%%edi \n"

      "cld \n"
      "movl    $8,%%ecx \n"
      "movl    $8,%%edx \n"
//height loop
"1:\n"
      "pushl   %%ecx \n"
"2:\n"
//width loop
      "movb    (%%esi),%%al \n"
      "movb    %%al,(%%edi) \n"
      "addl    _xmove,%%edi \n"
      "incl    %%esi \n"
      "loop    2b \n"
//move onto next line
      "addl    _ymove,%%edi \n"
//get width size back and loop
      "popl    %%ecx \n"
      "decl    %%edx \n"
      "jnz     1b \n"

      "popw    %%es \n"


//outputs (clobbered inputs)
		: "=a" (dummy1),
        "=S" (dummy2),
        "=D" (dummy3),
        "=b" (dummy4),
        "=c" (dummy5)
// inputs -
      :"0" (DataSeg),
       "1" (pWork),
       "2" (pScreen),
       "3" (x),
       "4" (y)
// registers modified
      :  "dx","cc", "memory"
	);
}

void disptranschar(int x,int y,int value,BYTE col)
{
   pBYTE pWork;
   int dummy1,dummy2,dummy3,dummy4,dummy5;
   int dirtval;

   if(x<0||y<0)
      return;

   dirtval=value|(int)(col<<8);
   if(pBoard->dirtyupd&&gendirty[(x>>3)+4][(y>>3)+4]==dirtval)
      return;

   DIRTYCHAR

   if(pBoard->dirtyupd)
      gendirty[(x>>3)+4][(y>>3)+4]=dirtval;

   if(FlipScreen)
   {
      pWork=&FlipGfx[COL_CHAR+(value<<6)];
      pMask=&FlipMask[(value<<6)];
   }
   else
   {
      pWork=&Gfx[COL_CHAR+(value<<6)];
      pMask=&Mask[(value<<6)];
   }

	__asm__ __volatile__
	(
		".align 4 \n"
//save es and set our selector
      "pushw   %%es  \n"
		"movw		%%ax,%%es \n"
//x,y
      "addl    $32,%%ebx \n"
      "addl    $32,%%ecx \n"
      "addl    %%ebx,%%edi \n"
      "shll    $9,%%ecx \n"
      "addl    %%ecx,%%edi \n"
//mask
      "movl    _pMask,%%ebx \n"
      "movl    $508,%%edx \n"

//blit line
      "movl    (%%edi),%%eax \n"
      "andl    (%%ebx),%%eax \n"
      "orl     (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%ebx \n"
      "addl    $4,%%edi \n"
      "movl    (%%edi),%%eax \n"
      "andl    (%%ebx),%%eax \n"
      "orl     (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%ebx \n"
//move onto next line
      "addl    %%edx,%%edi \n"

//blit line
      "movl    (%%edi),%%eax \n"
      "andl    (%%ebx),%%eax \n"
      "orl     (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%ebx \n"
      "addl    $4,%%edi \n"
      "movl    (%%edi),%%eax \n"
      "andl    (%%ebx),%%eax \n"
      "orl     (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%ebx \n"
//move onto next line
      "addl    %%edx,%%edi \n"

//blit line
      "movl    (%%edi),%%eax \n"
      "andl    (%%ebx),%%eax \n"
      "orl     (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%ebx \n"
      "addl    $4,%%edi \n"
      "movl    (%%edi),%%eax \n"
      "andl    (%%ebx),%%eax \n"
      "orl     (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%ebx \n"
//move onto next line
      "addl    %%edx,%%edi \n"

//blit line
      "movl    (%%edi),%%eax \n"
      "andl    (%%ebx),%%eax \n"
      "orl     (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%ebx \n"
      "addl    $4,%%edi \n"
      "movl    (%%edi),%%eax \n"
      "andl    (%%ebx),%%eax \n"
      "orl     (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%ebx \n"
//move onto next line
      "addl    %%edx,%%edi \n"

//blit line
      "movl    (%%edi),%%eax \n"
      "andl    (%%ebx),%%eax \n"
      "orl     (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%ebx \n"
      "addl    $4,%%edi \n"
      "movl    (%%edi),%%eax \n"
      "andl    (%%ebx),%%eax \n"
      "orl     (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%ebx \n"
//move onto next line
      "addl    %%edx,%%edi \n"

//blit line
      "movl    (%%edi),%%eax \n"
      "andl    (%%ebx),%%eax \n"
      "orl     (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%ebx \n"
      "addl    $4,%%edi \n"
      "movl    (%%edi),%%eax \n"
      "andl    (%%ebx),%%eax \n"
      "orl     (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%ebx \n"
//move onto next line
      "addl    %%edx,%%edi \n"

//blit line
      "movl    (%%edi),%%eax \n"
      "andl    (%%ebx),%%eax \n"
      "orl     (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%ebx \n"
      "addl    $4,%%edi \n"
      "movl    (%%edi),%%eax \n"
      "andl    (%%ebx),%%eax \n"
      "orl     (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%ebx \n"
//move onto next line
      "addl    %%edx,%%edi \n"

//blit line
      "movl    (%%edi),%%eax \n"
      "andl    (%%ebx),%%eax \n"
      "orl     (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"
      "addl    $4,%%esi \n"
      "addl    $4,%%ebx \n"
      "addl    $4,%%edi \n"
      "movl    (%%edi),%%eax \n"
      "andl    (%%ebx),%%eax \n"
      "orl     (%%esi),%%eax \n"
      "movl    %%eax,(%%edi) \n"


      "popw    %%es \n"

//outputs (clobbered inputs)
		: "=a" (dummy1),
        "=S" (dummy2),
        "=D" (dummy3),
        "=b" (dummy4),
        "=c" (dummy5)
// inputs -
      :"0" (DataSeg),
       "1" (pWork),
       "2" (pScreen),
       "3" (x),
       "4" (y)
// registers modified
      :  "dx","cc", "memory"
	);
}


void disp32sprite(int x,int y,int value,BYTE col,int flipx,int flipy)
{
   int x1,y1,dummy1,dummy2,dummy3,temp;
   int ymove,xmove;
   pBYTE pWork;
   pBYTE pWork2;

   x+=32;
   y+=32;

   pWork=pScreen+x+(y<<9);

   pWork2=&BigSprites[COL_BIG+(value<<10)];


   xmove=1;


   if(flipy)
   {
      pWork+=0x3e00;
      ymove=-0x220;
   }
   else
      ymove=0x1e0;


   if(flipx)
   {
      pWork+=31;
      xmove=-1;
      ymove+=64;
   }

	__asm__ __volatile__
	(
		".align 4 \n"
//save es and set our selector
		"pushw		%%es	\n"
		"movw		%%ax,%%es \n"
      "cld \n"
      "movl    $32,%%ecx \n"
      "movl    %%ecx,%%edx \n"
      "movb    _transcol,%%ah \n"
//height loop
"1:\n"
      "pushl   %%ecx \n"
//width loop
"2:\n"
      "movb    (%%esi),%%al \n"
      "cmpb    %%ah,%%al \n"
      "je      3f \n"
      "movb    %%al,(%%edi) \n"
"3:\n"
      "addl    %3,%%edi \n"
      "incl    %%esi \n"
      "loop    2b \n"
//move onto next line
      "addl    %4,%%edi \n"
//get width size back and loop
      "popl    %%ecx \n"
      "decl    %%edx \n"
      "jnz     1b \n"

      "popw    %%es \n"

//outputs (clobbered inputs)
		: "=a" (dummy1),
        "=S" (dummy2),
        "=D" (dummy3)
// inputs -
      : "g" (xmove),
        "g" (ymove),
        "0" (DataSeg),
        "1" (pWork2),
        "2" (pWork)
// registers modified
      :  "cx","dx","cc", "memory"
	);

}
void flipchars(int cols,int chars)
{
   int x,y,cindex,plane,col,prey1,prey2;
   int preindex;
   BYTE temp[8*8];
   BYTE temp2[8*8];

   for(col=0;col<cols;col++)
   {
      for(cindex=0;cindex<chars;cindex++)
      {
         preindex=COL_CHAR+(cindex<<6);
         for(y=0;y<8;y++)
         {
            prey1=7-y;
            prey2=y<<3;
            for(x=0;x<8;x++)
            {
               temp[(7-x)+(prey1<<3)]=Gfx[preindex+x+prey2];
               if(!col)
                  temp2[(7-x)+(prey1<<3)]=Mask[preindex+x+prey2];
            }

         }
         memcpy(&FlipGfx[preindex],temp,64);
         if(!col)
            memcpy(&FlipMask[preindex],temp2,64);
      }
   }
}

void rotchars(int cols,int chars)
{
   int x,y,cindex,plane,col,prey1,prey2;
   int preindex;
   BYTE temp[64];
   BYTE temp2[64];
   BYTE temp3[64];
   BYTE temp4[64];


   for(col=0;col<cols;col++)
   {
      for(cindex=0;cindex<chars;cindex++)
      {

         preindex=COL_CHAR+(cindex<<6);
         for(y=0;y<8;y++)
         {
            prey1=7-y;
            prey2=y<<3;
            for(x=0;x<8;x++)
            {
               temp[prey1+(x<<3)]=Gfx[preindex+x+prey2];
               temp2[y+((7-x)<<3)]=Gfx[preindex+x+prey2];
               if(!col)
               {
                  temp3[prey1+(x<<3)]=Mask[preindex+x+prey2];
                  temp4[y+((7-x)<<3)]=Mask[preindex+x+prey2];
               }

            }
         }
         memcpy(&Gfx[preindex],temp,64);
         memcpy(&FlipGfx[preindex],temp2,64);
         if(!col)
         {
            memcpy(&Mask[preindex],temp3,64);
            memcpy(&FlipMask[preindex],temp4,64);
         }
      }
   }
}

void rotsprites(int cols,int sprites)
{
   int x,y,cindex,plane,col,prey1,prey2;
   int preindex;
   BYTE temp[16*16];

   if(!sprites)
      return;

   for(col=0;col<cols;col++)
   {
      for(cindex=0;cindex<sprites;cindex++)
      {
         preindex=COL_SPRITE+(cindex<<8);
         for(y=0;y<16;y++)
         {
            prey1=15-y;
            prey2=y<<4;

            for(x=0;x<16;x++)
               temp[prey1+(x<<4)]=Sprites[preindex+x+prey2];
         }
         memcpy(&Sprites[preindex],temp,256);
      }
   }
}

void rotbigsprites(int cols,int sprites)
{
   int x,y,cindex,plane,col,prey1,prey2;
   int preindex;
   BYTE temp[32*32];

   if(!sprites)
      return;

   for(col=0;col<cols;col++)
   {
      for(cindex=0;cindex<sprites;cindex++)
      {
         preindex=COL_BIG+(cindex<<10);
         for(y=0;y<32;y++)
         {
            prey1=31-y;
            prey2=y<<5;

            for(x=0;x<32;x++)
               temp[prey1+(x<<5)]=BigSprites[preindex+x+prey2];
         }
         memcpy(&BigSprites[preindex],temp,32*32);
      }
   }
}

void rottiles(int cols,int tiles)
{
   int x,y,cindex,plane,col,prey1,prey2;
   int preindex;
   BYTE temp[16*16];


   for(col=0;col<cols;col++)
   {
      for(cindex=0;cindex<tiles;cindex++)
      {
         preindex=COL_TILE+(cindex<<8);
         for(y=0;y<16;y++)
         {
            prey1=15-y;
            prey2=y<<4;
            for(x=0;x<16;x++)
               temp[prey1+(x*16)]=Tiles[preindex+x+prey2];
         }
         memcpy(&Tiles[preindex],temp,256);
      }
   }
}

void flipscreenw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   value&=1;
   if(ror||flipxy)
      value=!value;

   if(!noflip)
   {
      if(FlipScreen!=value)
      {
         markalldirty();
         fastclear();
      }
      FlipScreen=value;
   }
   attemptflip=value;
}

void ivflipscreenw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   flipscreenw(offset,(~value&1),mwb);
}






int remapcolour(int coltomap,pPALETTE pPalette,int nocols)
{
   int newcol,i,val,r,g,b;
   int lowval=0xffff;

   newcol=coltomap;

   for(i=0;i<nocols;i++)
   {
      if(i!=coltomap)
      {
         r=abs(pPalette[i].r-pPalette[coltomap].r);
         g=abs(pPalette[i].g-pPalette[coltomap].g);
         b=abs(pPalette[i].b-pPalette[coltomap].b);
         val=(r+g+b);
         if(val<lowval)
         {
            lowval=val;
            newcol=i;
         }
      }
   }
   loginfo("colour %d :r=%d,g=%d,b=%d remapped to %d :r=%d,g=%d,b=%d",
               coltomap,
               pPalette[coltomap].r,
               pPalette[coltomap].g,
               pPalette[coltomap].b,
               newcol,
               pPalette[newcol].r,
               pPalette[newcol].g,
               pPalette[newcol].b);


   return newcol;
}

