#include "main.h"
#include "zaxvid.h"
#include "galvid.h"
#include "globals.h"
#include "twk.h"

pBYTE zaxback;
pBYTE ZaxPBack1;
pBYTE ZaxPBack2;
pBYTE ZaxPBackFlip1;
pBYTE ZaxPBackFlip2;

pBYTE pBackStart;

extern int precalculate;

void initzax(void)
{
   zaxback=myalloc(0x8000);
   if(!realorient)
   {
      ZaxPBack1=myalloc(0x123e00);
      ZaxPBack2=myalloc(0x123e00);
      ZaxPBackFlip1=myalloc(0x123e00);
      ZaxPBackFlip2=myalloc(0x123e00);
   }
   else
   {
      ZaxPBack1=myalloc(0x120000);
      ZaxPBack2=myalloc(0x120000);
      ZaxPBackFlip1=myalloc(0x120000);
      ZaxPBackFlip2=myalloc(0x120000);
   }

   memset(zaxback,0,0x8000);
   pBackStart=pScreen+32+(32*512);
}

void clearzax(void)
{
   myfree(zaxback);
   myfree(ZaxPBack1);
   myfree(ZaxPBack2);
   myfree(ZaxPBackFlip1);
   myfree(ZaxPBackFlip2);

}

void zaxint(void)
{
   if(pCode[0xfff0])
      mz80int(0xff);
}

void updatezaxscreen()
{
   int col,spr,x,y,prey1,prey2,y1;
   int idx;
   int backoff;

   if(pCode[0xfffb])
   {
      backoff=pCode[0xfff8]+(pCode[0xfff9]<<8);
      drawzaxback(backoff);
   }
   else
      fastclear();

   if(realorient)
   {

      if(FlipScreen)
      {
         for(idx=0xa0fc;idx>=0xa000;idx-=4)
         {
            if(pCode[idx]!=0xff)
               disp32sprite((249-pCode[idx+3])&0xff,pCode[idx]-15,
                              pCode[idx+1]&0x3f,pCode[idx+2]&0x1f,
                              !(pCode[idx+1]&0x40),!(pCode[idx+1]&0x80));
         }
         for(y=2;y<30;y++)
         {
            prey1=(31-y)<<3;
            prey2=y<<5;
            for(x=0;x<32;x++)
            {
               spr=pCode[0x8000+x+prey2];
               if(spr!=96)
               {
                  col=(collookups[0][x+((y>>2)<<5)]&0x0f)+((pCode[0xfff1]&1)<<4);
                  if(spr==16)
                     dispchar((31-x)<<3,prey1,spr,col);
                  else
                     disptranschar((31-x)<<3,prey1,spr,col);
               }
            }
         }
      }
      else
      {
         for(idx=0xa0fc;idx>=0xa000;idx-=4)
         {
            if(pCode[idx]!=0xff)
               disp32sprite(((pCode[idx+3]+16)&0xff)-32,255-pCode[idx]-16,
                              pCode[idx+1]&0x3f,pCode[idx+2]&0x1f,
                              pCode[idx+1]&0x40,pCode[idx+1]&0x80);
         }

         for(y=2;y<30;y++)
         {
            prey1=y<<3;
            prey2=y<<5;
            for(x=0;x<32;x++)
            {
               spr=pCode[0x8000+x+prey2];
               if(spr!=96)
               {
                  col=(collookups[0][x+((y>>2)<<5)]&0x0f)+((pCode[0xfff1]&1)<<4);
                  if(spr==16)
                     dispchar(x<<3,prey1,spr,col);
                  else
                     disptranschar(x<<3,prey1,spr,col);
               }
            }
         }
      }
   }
   else
   {

      if(FlipScreen)
      {
         for(idx=0xa0fc;idx>=0xa000;idx-=4)
         {
            if(pCode[idx]!=0xff)
               disp32sprite((223-pCode[idx])+1,(255-((pCode[idx+3]+16)&0xff))+1,
                              pCode[idx+1]&0x3f,pCode[idx+2]&0x1f,
                              !(pCode[idx+1]&0x80),!(pCode[idx+1]&0x40));
         }

         for(y=2;y<30;y++)
         {
            prey1=(y-1)<<3;
            prey2=y<<5;
            for(x=0;x<32;x++)
            {
               spr=pCode[0x8000+x+prey2];
               if(spr!=96)
               {
                  col=(collookups[0][x+((y>>2)<<5)]&0x0f)+((pCode[0xfff1]&1)<<4);
                  if(spr==16)
                     dispchar(prey1,(31-x)<<3,spr,col);
                  else
                     disptranschar(prey1,(31-x)<<3,spr,col);
               }
            }
         }
      }
      else
      {
         for(idx=0xa0fc;idx>=0xa000;idx-=4)
         {
            if(pCode[idx]!=0xff)
               disp32sprite(pCode[idx]-16,((pCode[idx+3]+16)&0xff)-32,
                              pCode[idx+1]&0x3f,pCode[idx+2]&0x1f,
                              pCode[idx+1]&0x80,pCode[idx+1]&0x40);
         }

         for(y=2;y<30;y++)
         {
            prey1=y<<3;
            prey2=y<<5;
            for(x=0;x<32;x++)
            {
               spr=pCode[0x8000+x+prey2];
               if(spr!=96)
               {
                  col=(collookups[0][x+((y>>2)<<5)]&0x0f)+((pCode[0xfff1]&1)<<4);
                  if(spr==16)
                     dispchar(240-prey1,x<<3,spr,col);
                  else
                     disptranschar(240-prey1,x<<3,spr,col);
               }
            }
         }
      }
   }
}


void zaxdecodegfx(pBYTE pIn,int nType)
{
   memcpy(zaxback,pIn+0xd000,0x8000);
}

void drawzaxback(int off)
{

   int trueoff;
   pBYTE pWork;
   pBYTE pOut;
   int x,y,idx,trip,skew;
   int x1,y1,len;



   if(realorient)
   {
      trip=0;

      if(FlipScreen)
      {
         trueoff=off<<1;
         if(pCode[0xfffa]&1)
            pWork=ZaxPBackFlip2+(trueoff<<8);
         else
            pWork=ZaxPBackFlip1+(trueoff<<8);
         skew=55;
         len=256;
      }
      else
      {
         trueoff=(4096+256)-(off<<1);
         if(pCode[0xfffa]&1)
            pWork=ZaxPBack2+(trueoff<<8);
         else
            pWork=ZaxPBack1+(trueoff<<8);
         skew=63;
         len=160;
      }

      pOut=pBackStart;
      for(y=0;y<240;y++)
      {
         memcpy(pOut,pWork+skew,len);
         pWork+=256;
         pOut+=512;
         trip++;
         if(trip&2)
         {
            trip=0;
            skew--;
            if(len<256)
               len++;
         }
      }
   }
   else
   {
      if(FlipScreen)
      {
         skew=-111;
         trueoff=off;
         if(pCode[0xfffa]&1)
            pWork=ZaxPBackFlip2+(trueoff<<9);
         else
            pWork=ZaxPBackFlip1+(trueoff<<9);

      }
      else
      {
         skew=-127;
         trueoff=2111-off;
         if(pCode[0xfffa]&1)
            pWork=ZaxPBack2+(trueoff<<9);
         else
            pWork=ZaxPBack1+(trueoff<<9);
      }


      pOut=pBackStart;


      for(y=0;y<256;y++)
      {
         memcpy(pOut,pWork+skew,240);
         pWork+=512;
         pOut+=512;
         skew+=2;
      }
   }
}

void zaxsetpal(pBYTE pIn)
{
   stdsetpal(pIn,256);
   memcpy(collookups[0],pIn+256,256);
}

void precalczaxback(void)
{
   pBYTE pIn;
   pBYTE pIn2;
   pBYTE pOut;
   pBYTE pOut2;
   pBYTE pOut3;
   pBYTE pOut4;
   pBYTE pTemp1;
   pBYTE pTemp2;
   pBYTE pTemp3;
   pBYTE pTemp4;
   char buffer[512];
   FILE *f;
   int idx,x,x2,y,x1,y1,col;
   int pre=0;
   pBYTE pZax1=0;
   pBYTE pZax2=0;
   pBYTE pZaxF1=0;
   pBYTE pZaxF2=0;

   if(realorient)
   {
      sprintf(buffer,"precalc\\back%d.pre",BoardIdx);
      f=fopen(buffer,"rb");
      if(f)
      {
         fread(ZaxPBack1,1,0x120000,f);
         fread(ZaxPBack2,1,0x120000,f);
         fread(ZaxPBackFlip1,1,0x120000,f);
         fread(ZaxPBackFlip2,1,0x120000,f);
         fclose(f);
         return;
      }
      memset(ZaxPBack1,0,0x120000);
      memset(ZaxPBack2,0,0x120000);
      memset(ZaxPBackFlip1,0,0x120000);
      memset(ZaxPBackFlip2,0,0x120000);

      pTemp1=ZaxPBack1+0x10000;
      pTemp2=ZaxPBack2+0x10000;
      pTemp3=ZaxPBackFlip1+0x10000;
      pTemp4=ZaxPBackFlip2+0x10000;
   }
   else
   {
      sprintf(buffer,"precalc\\rback%d.pre",BoardIdx);
      f=fopen(buffer,"rb");
      if(f)
      {
         fread(ZaxPBack1,1,0x123e00,f);
         fread(ZaxPBack2,1,0x123e00,f);
         fread(ZaxPBackFlip1,1,0x123e00,f);
         fread(ZaxPBackFlip2,1,0x123e00,f);
         fclose(f);
         return;
      }

      memset(ZaxPBack1,0,0x123e00);
      memset(ZaxPBack2,0,0x123e00);
      memset(ZaxPBackFlip1,0,0x123e00);
      memset(ZaxPBackFlip2,0,0x123e00);

      pZax1=myalloc(0x120000);
      pZax2=myalloc(0x120000);
      memset(pZax1,0,0x120000);
      memset(pZax2,0,0x120000);
      pZaxF1=myalloc(0x120000);
      pZaxF2=myalloc(0x120000);
      memset(pZaxF1,0,0x120000);
      memset(pZaxF2,0,0x120000);

      pTemp1=pZax1;
      pTemp2=pZax2;
      pTemp3=pZaxF1;
      pTemp4=pZaxF2;

   }



   for(idx=0;idx<0x4000;idx++)
   {
      y=idx>>5;
      x=idx&0x1f;

      pOut=pTemp1+(x<<3)+(y<<11);
      pOut2=pTemp2+(x<<3)+(y<<11);
      pIn=Tiles+((zaxback[idx]+((zaxback[idx+0x4000]&3)<<8))<<6);
      pOut3=pTemp3+((31-x)<<3)+((511-y)<<11);
      pOut4=pTemp4+((31-x)<<3)+((511-y)<<11);
      pIn2=Tiles+((zaxback[idx]+((zaxback[idx+0x4000]&3)<<8))<<6)+63;


      col=zaxback[0x4000+idx]>>4;
      for(y1=0;y1<8;y1++)
      {
         for(x1=0;x1<8;x1++,pIn++,pIn2--,pOut++,pOut2++,pOut3++,pOut4++)
         {
            *pOut3=*pIn2+(col<<3);
            *pOut4=*pIn2+((col|0x10)<<3);
            *pOut=*pIn+(col<<3);
            *pOut2=*pIn+((col|0x10)<<3);
         }
         pOut+=248;
         pOut2+=248;
         pOut3+=248;
         pOut4+=248;
      }
   }

   if(!realorient)
   {
      for(idx=-510;idx<4096;idx+=2)
		{
         x2=(2047+64)-(idx>>1);
         x=(2047)-(idx>>1);

         for(y=0;y<512;y+=2)
			{
            if(idx+y>=0&&idx+y<4096)
				{
               ZaxPBack1[y+(x<<9)]=pZax1[((4095-(idx+y))<<8)+(y>>1)];
               ZaxPBack2[y+(x<<9)]=pZax2[((4095-(idx+y))<<8)+(y>>1)];
               ZaxPBack1[((y+1))+(x<<9)]=pZax1[((4095-(idx+y+1))<<8)+(y>>1)];
               ZaxPBack2[((y+1))+(x<<9)]=pZax2[((4095-(idx+y+1))<<8)+(y>>1)];

               ZaxPBackFlip1[y+(x2<<9)]=pZaxF1[((4095-(idx+y))<<8)+(y>>1)];
               ZaxPBackFlip2[y+(x2<<9)]=pZaxF2[((4095-(idx+y))<<8)+(y>>1)];
               ZaxPBackFlip1[((y+1))+(x2<<9)]=pZaxF1[((4095-(idx+y+1))<<8)+(y>>1)];
               ZaxPBackFlip2[((y+1))+(x2<<9)]=pZaxF2[((4095-(idx+y+1))<<8)+(y>>1)];
				}
			}
		}
      myfree(pZax1);
      myfree(pZax2);
      myfree(pZaxF1);
      myfree(pZaxF2);
   }

   if(precalculate)
   {
      if(realorient)
      {
         sprintf(buffer,"precalc\\back%d.pre",BoardIdx);
         f=fopen(buffer,"wb");
         if(f)
         {
            fwrite(ZaxPBack1,1,0x120000,f);
            fwrite(ZaxPBack2,1,0x120000,f);
            fwrite(ZaxPBackFlip1,1,0x120000,f);
            fwrite(ZaxPBackFlip2,1,0x120000,f);
            fclose(f);
         }
      }
      else
      {
         sprintf(buffer,"precalc\\rback%d.pre",BoardIdx);
         f=fopen(buffer,"wb");
         if(f)
         {
            fwrite(ZaxPBack1,1,0x123e00,f);
            fwrite(ZaxPBack2,1,0x123e00,f);
            fwrite(ZaxPBackFlip1,1,0x123e00,f);
            fwrite(ZaxPBackFlip2,1,0x123e00,f);
            fclose(f);
         }
      }
   }
}



void initszax(void)
{

   szaxxon_decode();
   initzax();

}

static void sega_decode(const unsigned char xortable[32][4])
{
	int A;

	int diff = 65563;

	unsigned char *rom = pCode;


	

	for (A = 0x0000;A < 0x8000;A++)
	{
		int row,col;
		unsigned char src;
		src = rom[A];
		/* pick the translation table from bits 0, 4, 8 and 12 of the address */
		row = (A & 1) + (((A >> 4) & 1) << 1) + (((A >> 8) & 1) << 2) + (((A >> 12) & 1) << 3);
		/* pick the offset in the table from bits 3 and 5 of the source data */
		col = ((src >> 3) & 1) + (((src >> 5) & 1) << 1);
		/* the bottom half of the translation table is the mirror image of the top */
		if (src & 0x80) col = 3 - col;

		/* decode the opcodes */
		rom[A + diff] = src ^ xortable[2*row][col];

		/* decode the data */
		rom[A] = src ^ xortable[2*row+1][col];

		if (xortable[2*row][col] == 0xff)	/* table incomplete! (for development) */
			rom[A+ diff] = 0x00;
		if (xortable[2*row+1][col] == 0xff)	/* table incomplete! (for development) */
			rom[A] = 0xee;
	}

	for (A = 0x8000;A < diff;A++)
		rom[A + diff] = rom[A];


}





void szaxxon_decode(void)
{
	static const unsigned char convtable[32][4] =
	{
		/*       opcode                   data                     address      */
		/*  A    B    C    D         A    B    C    D                           */
		{ 0x88,0xa8,0x80,0xa0 }, { 0x28,0x20,0xa8,0xa0 },	/* ...0...0...0...0 */
		{ 0x08,0x28,0x88,0xa8 }, { 0x88,0x80,0x08,0x00 },	/* ...0...0...0...1 */
		{ 0xa8,0x28,0xa0,0x20 }, { 0x20,0xa0,0x00,0x80 },	/* ...0...0...1...0 */
		{ 0x88,0xa8,0x80,0xa0 }, { 0x28,0x20,0xa8,0xa0 },	/* ...0...0...1...1 */
		{ 0x08,0x28,0x88,0xa8 }, { 0x88,0x80,0x08,0x00 },	/* ...0...1...0...0 */
		{ 0x88,0xa8,0x80,0xa0 }, { 0x28,0x20,0xa8,0xa0 },	/* ...0...1...0...1 */
		{ 0xa8,0x28,0xa0,0x20 }, { 0x20,0xa0,0x00,0x80 },	/* ...0...1...1...0 */
		{ 0x08,0x28,0x88,0xa8 }, { 0x88,0x80,0x08,0x00 },	/* ...0...1...1...1 */
		{ 0x08,0x28,0x88,0xa8 }, { 0x88,0x80,0x08,0x00 },	/* ...1...0...0...0 */
		{ 0x88,0xa8,0x80,0xa0 }, { 0x28,0x20,0xa8,0xa0 },	/* ...1...0...0...1 */
		{ 0x88,0xa8,0x80,0xa0 }, { 0x28,0x20,0xa8,0xa0 },	/* ...1...0...1...0 */
		{ 0xa8,0x28,0xa0,0x20 }, { 0x20,0xa0,0x00,0x80 },	/* ...1...0...1...1 */
		{ 0xa8,0x28,0xa0,0x20 }, { 0x20,0xa0,0x00,0x80 },	/* ...1...1...0...0 */
		{ 0xa8,0x28,0xa0,0x20 }, { 0x20,0xa0,0x00,0x80 },	/* ...1...1...0...1 */
		{ 0x08,0x28,0x88,0xa8 }, { 0x88,0x80,0x08,0x00 },	/* ...1...1...1...0 */
		{ 0x88,0xa8,0x80,0xa0 }, { 0x28,0x20,0xa8,0xa0 }	/* ...1...1...1...1 */
	};

   	sega_decode(convtable);
}


